unit light;

interface

uses
  Windows, Graphics,types,ABitmaplight,sysUtils;

procedure EffectLightMode(var SrcBitmap :TBitmap;Value:Integer);
procedure EffectEnbos(var SrcBitmap :TBitmap);
procedure EffectMirror(var SrcBitmap :TBitmap);
procedure EffectFlip(var SrcBitmap :TBitmap);
procedure EffectSepia(var SrcBitmap :TBitmap;effect:Integer=0);
procedure EffectCustom(var SrcBitmap: TBitmap;masktype:Integer);
procedure EffectNOTMask(var srcBitmap: TBitmap);
procedure EffectShiftRGB(var SrcBitmap: TBitmap;mode:Integer);
procedure EffectMono(var SrcBitmap:TBitmap;value:smallInt);
procedure EffectThreadLine(var SrcBitmap:TBitmap;const effect:Integer=0);
procedure EffectKakusan(var srcBitmap: TBitmap);
procedure EffectNoize(var SrcBitmap:TBitmap;noise:smallInt;const mode:shortInt);
procedure EffectResize(Var srcBitmap:TBitmap;const width,height:Integer;smooth:boolean=false);
//procedure EffectResizeEffectResizeSmooth(Var SrcBitmap:TBitmap;const width,height:Integer);
procedure EffectsTurn270(var SrcBitmap:TBitmap);
procedure EffectsTurn90(var SrcBitmap:TBitmap);
procedure EffectsMosaic(var SrcBitmap:TBitmap;Value:Integer);
procedure Set32bit(var Src,Dest :TBitmap);
procedure EffectClip(var SrcBitmap:TBitmap;Clip:TRect);
//procedure EffectResizeNormal(var SrcBitmap:TBitmap;const width,height:Integer);

type
TADCanvas= class(TCanvas)
private
 bmpBkg:TABitmap;
public
 constructor create();
 destructor destroy();override;
 procedure StretchDrawEx(Dest:TRect;Bitmap:TBitmap;mode:shortInt;alpha:byte=127);
 procedure DrawLogic(Dest:TRect;Graphic:TGraphic;mode:shortInt=0);
 procedure DrawTranslucent (Dest:TRect;bitmap:TBitmap;alpha:byte);
end;

type
 //32bitANZXp|C^
 TRGBarray  = array[0..0] of TRGBQUAD; //None e
 pRGBarray  = ^TRGBarray;

type
 //32bitANZXp_u|C^
 PPBits = ^TPBits;
 TPBits = array[0..0] of pRGBarray; //None e

implementation


procedure Set32bit(var Src,Dest :Tbitmap);
begin
  Src.PixelFormat :=pf32bit;
  Dest.PixelFormat:=pf32bit;
  Dest.Width:=Src.Width;
  Dest.Height:=Src.Height;
end;

function SetOutXYWHSuper(var ix,iy,iw,ih:Double;var ox,oy:Double;var ow,oh:Integer;iWW,iHH,oWW,oHH:Integer):Boolean;
var iZW,iZH:Double;
begin

   iZW:=iw/ow;
   iZH:=ih/oh;


   Result:=False;

   //͈ʒuςȃmIB
   if (ix<0) or (ix>iWW) then exit;
   if (iy<0) or (iy>iHH) then exit;

   //o͈ʒu͓K؂ׂB
   If oX>=oWW then exit;
   If oY>=oHH then exit;
   If oX+oW<=0 then exit;
   If oY+oH<=0 then exit;


   {\GAɓTCYŁA}CiXȏꍇ}
   //}CiX̏ꍇ̕ύX
   If oX<0 then begin
      //̓TCY̕ύX
      iw:=iZW*(oW+oX);
      iX:=iX+Abs(oX)*iZW;

      oW:=Trunc(oW+oX);
      oX:=0;

   end;

   If oY<0 then begin
      //̓TCY̕ύX
      ih:=iZH*oh;
      iy:=iY+(Abs(oY)*iZH);

      oH:=Trunc(oH+oY);
      oY:=0;
   end;

   {\GAzĂ邾̏ꍇ}
   //͈͉z̎̕ύXB
   If oX+oW>oWW then begin
      //͈ʒuύXĂB
      iW:=iZW*(oWW-oX);

      //XđB
      oW:=Trunc(oWW-oX);
   end;

   If oY+oH>oHH then begin
      //͈ʒuύXĂB
      iH:=iZH*(oHH-oY);

      //XđB
      oH:=Trunc(oHH-oY);
   end;


   //ҏWʂ̃`FbNB
   if ow<=0 then exit;
   if oh<=0 then exit;
   if (ix<0) or (ix>iww) then exit;
   if (iy<0) or (iy>ihh) then exit;
   if (ix+iw)>iWW then iw:=iWW-iX;
   if (iy+ih)>iHH then ih:=iHH-iY;

   //ShowMessage(Format('%d,%d %d,%d',[iw,ih,ow,oh]));

   //ʃIbP[B
   Result:=True;

end;



constructor TADCanvas.create();
begin
 inherited;
 bmpBkg:=TABitmap.create();
 bmpBkg.pixelformat:=pf32bit;
end;

destructor TADCanvas.destroy();
begin
 bmpBkg.Free();
 inherited;
end;

procedure TADCanvas.StretchDrawEx(Dest:TRect;Bitmap:TBitmap;mode:shortInt;alpha:byte=127);
begin

  case mode of
   1:self.DrawLogic
    (Dest,bitmap,1);
   2:self.DrawLogic
    (Dest,bitmap,2);
   3:self.DrawTranslucent
    (Dest,bitmap,alpha);
   4:self.DrawTranslucent
    (Dest,bitmap,alpha);
   else
    self.StretchDraw(Dest,bitmap);
   end;
    
end;


procedure TADCanvas.DrawTranslucent
 (Dest:TRect;bitmap:TBitmap;alpha:byte);
var
  w,h: Integer;
  subBitmap:TBitmap;
  color:TColor;
begin

  // wi\t͈͂̑傫A؂

  h:=Dest.Bottom - Dest.Top;
  w:=Dest.Right - Dest.Left;

 // bitmap.PixelFormat:=pf32bit;
  bmpBkg.Width:=w;
  bmpBkg.Height:=h;
  bmpBkg.Canvas.CopyRect(bmpBkg.Canvas.ClipRect,bitmap.Canvas,bitmap.Canvas.ClipRect);
//  bmpBkg.Assign(bitmap);

  subBitmap:=TBitmap.Create();
  subBitmap.PixelFormat:=pf32bit;
  subBitmap.Width:=w;
  subBitmap.Height:=h;
  stretchBlt(subBitmap.Canvas.Handle,0,0,w,h,
   self.Handle,Dest.Left,Dest.Top,Dest.Right-Dest.Left,
   Dest.Bottom-Dest.Top,SrcCopy);

  if(bitmap.Transparent)then
  begin
   bmpBkg.GetRGBColor(0,0,color);
   bmpBkg.ColorKeyAlphaMMX(0,0,w,h,0,0,subbitmap,color,alpha);
  end
  else
   bmpBkg.ColorAlphaMMX(0,0,w,h,0,0,subbitmap,alpha);


  BitBlt(Handle,Dest.Left,Dest.Top,w,h,
    subbitmap.Canvas.Handle,0,0,SrcCopy);
  subBitmap.Free();

end;

(*andorɂ`sȂ*)
procedure TADCanvas.DrawLogic(Dest:TRect;Graphic:TGraphic;mode:shortInt=0);
var
 dwRop:Cardinal;
begin


 case mode of
 1:
 begin
  bmpBkg.Canvas.Brush.Color:=$ffffff;
  self.CopyMode:=cmSrcAnd;
  dwRop:=SRCAND;
 end;
 2:
 begin
  bmpBkg.Canvas.Brush.Color:=0;
  self.CopyMode:=cmSrcPaint;
  dwRop:=SRCPAINT;
 end;
 else exit;
 end;

 bmpBkg.Width:=Dest.Right-Dest.Left;
 bmpBkg.Height:=Dest.Bottom-Dest.Top;

 bmpBkg.Canvas.FillRect(bmpBkg.Canvas.ClipRect);

 bmpBkg.Canvas.StretchDraw(bmpBkg.Canvas.ClipRect,Graphic);
 bitBlt(Handle,Dest.Left,Dest.Top,bmpBkg.Width,bmpBkg.Height,
   bmpBkg.Canvas.Handle,0,0,dwRop);


end;

(*UCNGtFNgsȂ*)
procedure EffectsMosaic(var SrcBitmap:TBitmap;Value:Integer);
var x,y:Integer;
    pBit,pBit2:PDWORDArray;

    //p
    bufX:PWORDArray;
begin

  if(value<1)then exit;

  GetMEM(bufX,(SrcBitmap.width+1)*2);

  for x:=0 to SrcBitmap.width-1 do begin
      bufX[x]:=((x) div Value)*Value;
  end;


  for y:=0 to SrcBitmap.height-1 do begin
      ///݂͉̓摜̍ʒu
      pBit :=SrcBitmap.ScanLine[y];
      pBit2:=SrcBitmap.ScanLine[(y div Value)*Value];

      for x:=0 to SrcBitmap.width-1 do begin
          pBit[x]:=pBit2[bufX[x]];
      end;
  end;

  FreeMEM(bufX);

end;


procedure EffectsTurn90(var SrcBitmap:TBitmap);
var
 Row,Col              : Integer;
 SrcRow               : pRGBArray;
 DestBitmap : TBitmap;
 DestBits : PPBits;
begin

  DestBitmap  :=TBitmap.Create;
  DestBitmap.Width:= SrcBitmap.Height;
  DestBitmap.Height:=SrcBitmap.Width;
  DestBitmap.PixelFormat:=pf32bit;
  SrcBitmap.PixelFormat:=pf32bit;

  GetMem(DestBits, DestBitmap.Height * SizeOf(pRGBArray));
 try

  for Row:= 0 to DestBitmap.Height - 1 do
   DestBits[Row]:=DestBitmap.Scanline[Row];

  for Row:=0 to SrcBitmap.Height-1 do
  begin
      SrcRow:=SrcBitmap.ScanLine[Row];

        for Col:=0 to SrcBitmap.Width-1 do
        begin
             //E90x]
          DestBits[Col][SrcBitmap.Height-1-Row]:=SrcRow[Col];
        end;
  end;

  FreeMem(DestBits); DestBits:=nil;
  SrcBitmap.Handle :=DestBitmap.ReleaseHandle;

  except
     if Assigned(DestBits) then FreeMem(DestBits);
     windows.MessageBox(0,'^[G[','EffectTurn90',MB_OK);
  end;

  DestBitmap.Free;
end;


(*E]*)
procedure EffectsTurn270(var SrcBitmap:TBitmap);
var
 Row,Col              : Integer;
 SrcRow               : pRGBArray;
 DestBitmap : TBitmap;
 DestBits : PPBits;
begin

  DestBitmap  :=TBitmap.Create;
  DestBitmap.Width:= SrcBitmap.Height;
  DestBitmap.Height:=SrcBitmap.Width;
  DestBitmap.PixelFormat:=pf32bit;
  SrcBitmap.PixelFormat:=pf32bit;
  
  GetMem(DestBits, DestBitmap.Height * SizeOf(pRGBArray));
 try

  for Row:= 0 to DestBitmap.Height - 1 do
    DestBits[Row]:=DestBitmap.Scanline[Row];

  for Row:=0 to SrcBitmap.Height-1 do
  begin
      SrcRow:=SrcBitmap.ScanLine[Row];

        for Col:=0 to SrcBitmap.Width-1 do
        begin
             //90x](E270])
         DestBits[SrcBitmap.Width-1-COl][ROw]:=SrcRow[Col];
        end;
  end;

  FreeMem(DestBits);
  DestBits:=nil;
  SrcBitmap.Handle :=DestBitmap.ReleaseHandle;

  except
     if Assigned(DestBits) then FreeMem(DestBits);
     windows.MessageBox(0,'E^[G[','EffectMono',MB_OK);
  end;
  DestBitmap.Free;
end;

//|ZZ[vň؎gȂgłdlBLbV܂܂
procedure EffectResizeNormal(ix2,iy2,iw2,ih2:Double;ox2,oy2:Double;ow2,oh2:Integer;InBMP,OutBMP:TBitmap);
var pBit,pBit2:PDWORDArray;
    y,x:Integer;//[vp
    zx,zy:Integer;//͂Ƃ̈ʒu
    mzoomx,mzoomy:Integer;//Y[{B

    //pB
    i:Integer;//X̑pB
    k:Integer;//ZẌړ̌vZB
    //p̂Q.
    l:Integer;//Ÿʒu̎ւ̒l̔䗦B
    //ix,
    iy:Integer;
    ix3,iy3,ox3,oy3,iw3,ih3:Double;
   // iw ,ih,
    ox,oy,ow,oh:Integer;
    ix8:Integer;
begin
  //ŋߖT@
  ix3:=ix2; iy3:=iy2; iw3:=iw2; ih3:=ih2;
  ox3:=ox2; oy3:=oy2; ow :=ow2; oh :=oh2;


  //t̃Y[{߂iY[ɂĂ邽)
  mzoomx:=Trunc(iw3*$FFFF / ow);//Ƃ͑SVtgőpł悤ɂB
  mzoomy:=Trunc(ih3*$FFFF / oh);

  //͈͓ǂ`FbNB
  If not SetoutXYWHSuper(ix3,iy3,iw3,ih3,ox3,oy3,ow,oh,InBMP.Width,InBMP.Height,OutBMP.Width,OutBMP.Height) then exit;

  //Yʒũ[vpB
  l:=1;


  ix8:=Trunc(ix3*$FFFF);
//  ix:=Trunc(ix3);
  iy:=Trunc(iy3);
  ox:=Trunc(ox3);
  oy:=Trunc(oy3);
 // iw:=Trunc(iw3);
 // ih:=Trunc(ih3);

  for y:=oy to oy+oh-1 do begin
      pBit2:=OutBMP.ScanLine[y];


      ///݂͉̓摜̍ʒuvZ
      zy:=iy+(l shr 16);

      pBit :=InBMP.ScanLine[zy];

      //x̑ppB
      i:=ox;
      k:=ix8;



      for x:=ox to ox+ow-1 do begin
          //͈ʒuZo
          zx:=(k shr 16);

          //
          //o
          pBit2[i]:=pBit[zx];
          inc(i);

          //ւ̈ʒu炷B
          inc(k,mzoomx);

      end;
      //ւ̈ʒu炷B
      l:=l+mzoomy;
  end;


end;


(*`⊮@ŃTCYύX*)
procedure EffectResizeSmooth(ix2,iy2,iw2,ih2:Double;ox2,oy2:Double;ow2,oh2:Integer;InBMP,OutBMP:TBitmap);
var pBit,pBitN,pBit2:PDWORDArray;
    y,x:Integer;//[vp
    zx,zy:Integer;//͂Ƃ̈ʒu
    mzoomx,mzoomy,zoomx,zoomy:DWORD;//Y[{B

    //pB
    i:Integer;//X̑pB
    k:Integer;//ZẌړ̌vZB
    //p̂Q.
    l:DWORD;//Ÿʒu̎ւ̒l̔䗦B

    ix8:Integer;
    //[̍lp
    tw,th:Integer;

    //pEoCjÅB
    l2,l3:DWORD;
    ix,iy,iw,ih,ox,oy,ow,oh:Integer;
    ix3,iy3,ox3,oy3,iw3,ih3:Double;

    //MMXp
    ew,ew2:Integer;
    iMM4:DWORD;
    ix8_2:Integer;
    ox4,ix4:Integer;

begin

  ix3:=ix2; iy3:=iy2; iw3:=iw2; ih3:=ih2;
  ox3:=ox2; oy3:=oy2; ow :=ow2; oh :=oh2;


  //t̃Y[{߂iY[ɂĂ邽)
  mzoomx:=Trunc(iw3*$FFFF / ow);//Ƃ͑SVtgőpł悤ɂB
  mzoomy:=Trunc(ih3*$FFFF / oh);

  //ʏ̃Y[{擾
  zoomx :=Trunc(ow*$FFFF / iw3);//Ƃ͑SVtgőpł悤ɂB
  zoomy :=Trunc(oh*$FFFF / ih3);

  //͈͓ǂ`FbNB
  If not SetoutXYWHSuper(ix3,iy3,iw3,ih3,ox3,oy3,ow,oh,InBMP.Width,InBMP.Height,OutBMP.Width,OutBMP.Height) then exit;

  //Yʒũ[vpB
  l:=0;

  ix8:=Trunc(ix3*($FFFF));
  //ix8:=Trunc(ix3) shl 16;

  ix:=Trunc(ix3);
  iy:=Trunc(iy3);
  ox:=Trunc(ox3);
  oy:=Trunc(oy3);
  iw:=Trunc(iw3);
  ih:=Trunc(ih3);

  //[lB([𔲂_ITCYB)
  tw:=(iw-1)*zoomx shr 16;
  if InBMP.Height>iy+ih then begin
     th:=oh;
  end else begin
     th:=(ih-1)*zoomy div $FFFF;
  end;

  zy:=-1;

  //MMXp
  iMM4:=$00FF00FF;
  //B
  ew:=tw;
  ew2:=ow-tw;

  ox4:=ox shl 2;

  //ix8_2:=(iw-2) shl 8;

  for y:=oy to oy+th-1 do begin
      pBit2:=OutBMP.ScanLine[y];


      ///݂͉̓摜̍ʒuvZ
      if zy<>iy+(l shr 16) then begin
         zy:=iy+(l shr 16);

         pBit :=InBMP.ScanLine[zy];
         pBitN:=InBMP.ScanLine[zy+1];
      end;
      //oCjÅiYj
      l3:=(l-((l shr 16) shl 16)) shr 8;//py


      asm
        push eax;push ebx;push ecx;push edx;push edi;push esi; // WX^ޔ

        //sNZʒu
        mov edi,pBit;//Src
        mov esi,pBitN;//Src+1
        mov ebx,pBit2;//Dest

        //JE^[B
        mov eax,ew;

        //o͈ʒu𒲐B
        add ebx,ox4;


        //܂Ă̂́Aecx,edx
        mov ecx,ix8;//ʒu̐Έʒuƒl̕ێ

        //
        pxor mm6,mm6;
        movd mm7,iMM4;//mm7ɂ́A$00FF00FFB
        punpckldq mm7,mm7;//$00FF00FF 00FF00FFƃRs[Bdword>qword

        //܂́Aʏ̃[vłB
        @LOOP1:
         //擾ʒuwB

            //摜̈ʒuvZB
            mov edx,ecx;
            shr edx,16;

            //摜̃|C^ړ
            //摜̓(64rbǵB)
            movq mm2,qword ptr[edi+edx*4];
            movq mm3,qword ptr[esi+edx*4];
            movq mm0,mm2;
            movq mm1,mm3;

            //摜𐮓
            psrlq mm2,32;
            psrlq mm3,32;

            //QWORDɍLČvZł悤ɂB
            punpcklbw mm0,mm6;// a
            punpcklbw mm1,mm6;// b
            punpcklbw mm2,mm6;// c
            punpcklbw mm3,mm6;// d

            //PX̌vZBk-(zx shl 8);
            shl  edx,16;
            movd mm5,edx;
            movd mm4,ecx;
            psubd mm4,mm5;
            psrld mm4,8;

            //LĂ
            punpcklwd mm4,mm4;// $00aa > $00aa00aa
            punpckldq mm4,mm4;// $00aa00aa > $00aa00aa 00aa00aa
            movq  mm5,mm7;//]pmm7
            psubw mm5,mm4;//]B

	    //(px*py*(a+d-b-c) shr 8)+px*(b-a)+py*(c-a)) shr 8)+a;
            pmullw mm0, mm5; // a * px
            pmullw mm1, mm5; // c * px
            pmullw mm2, mm4; // b * (1 - px)
            pmullw mm3, mm4; // d * (1 - px)

            //PY̌vZBƂĂvZς݁B
            movd mm4,l3; // a_dy
            punpcklwd mm4,mm4; //[h_u[h
            punpckldq mm4,mm4; // 0x00bb00bb 00bb00bb
            movq mm5, mm7;//]pmm7
            psubw mm5,mm4;//]B

            //B
            paddusw mm0, mm2;  // (a * px + b * (1 - px))
            paddusw mm1, mm3;  // (c * px + d * (1 - px))
            psrlw mm0, 8;
            psrlw mm1, 8;
            pmullw mm0, mm5; // (a * px + b * (1 - px)) * py
            pmullw mm1, mm4; // (c * px + d * (1 - px)) * (1 - py)
            paddusw  mm0, mm1;  //
            psrlw    mm0, 8;
            packuswb mm0, mm6; // 0x00 00 00 00 B1' R0' G0' B0'

            //o͂̏
            movd dword ptr[ebx],mm0;
            add ebx,4;

            //K𑝂₷B
            add ecx,mzoomx;

            dec eax;

            jne @LOOP1;

        //E[̓ꃋ[vAB

        //JE^[B
        mov eax,ew2;

        //܂Ă̂́Aecx,edx
        //mov ecx,ix8_2;//ʒu̐Έʒuƒl̕ێ

        //߂
        sub ecx,mzoomx;


        @LOOP2:
         //擾ʒuwB

            //摜̈ʒuvZB
            mov edx,ecx;
            shr edx,16;

            //摜̃|C^ړ
            //摜̓(64rbǵB)
            movq mm0,qword ptr[edi+edx*4];
            movq mm1,qword ptr[esi+edx*4];
            movq mm2,mm0;
            movq mm3,mm1;

            //摜𐮓
            psrlq mm2,32;
            psrlq mm3,32;

            //QWORDɍLČvZł悤ɂB
            punpcklbw mm0,mm6;// a
            punpcklbw mm1,mm6;// c
            punpcklbw mm2,mm6;// b
            punpcklbw mm3,mm6;// d

            //PX̌vZBk-(zx shl 8);
            shl  edx,16;
            movd mm4,ecx;
            movd mm5,edx;
            psubd mm4,mm5;
            psrld mm4,8;
            
            //LĂ
            punpcklwd mm4,mm4;// $00aa > $00aa00aa
            punpckldq mm4,mm4;// $00aa00aa > $00aa00aa 00aa00aa
            movq  mm5,mm7;//]pmm7
            psubw mm5,mm4;//]B

	    //(px*py*(a+d-b-c) shr 8)+px*(b-a)+py*(c-a)) shr 8)+a;
            pmullw mm0, mm5; // a * px
            pmullw mm1, mm5; // c * px
            pmullw mm2, mm4; // b * (1 - px)
            pmullw mm3, mm4; // d * (1 - px)

            //PY̌vZBƂĂvZς݁B
            movd mm4,l3; // a_dy
            punpcklwd mm4,mm4; //[h_u[h
            punpckldq mm4,mm4; // 0x00bb00bb 00bb00bb
            movq mm5, mm7;//]pmm7
            psubw mm5,mm4;//]B

            //B
            paddusw mm0, mm2;  // (a * px + b * (1 - px))
            paddusw mm1, mm3;  // (c * px + d * (1 - px))
            psrlw mm0, 8;
            psrlw mm1, 8;
            pmullw mm0, mm5; // (a * px + b * (1 - px)) * py
            pmullw mm1, mm4; // (c * px + d * (1 - px)) * (1 - py)
            paddusw  mm0, mm1;  //
            psrlw    mm0, 8;
            packuswb mm0, mm6; // 0x00 00 00 00 B1' R0' G0' B0'

            //o͂̏
            movd dword ptr[ebx],mm0;
            add ebx,4;
            
            //K𑝂₷B
            add ecx,mzoomx;

            dec eax;

            jne @LOOP2;

        
        emms;
        pop esi;pop edi;pop edx;pop ecx;pop ebx;pop eax;    // WX^
      end;

      //ւ̈ʒu炷B
      l:=l+mzoomy;
  end;


  if InBMP.Height>iy+ih then exit;

  zy:=iy+ih-1;
  l:=(ih-1)*($FFFF+1);


  for y:=oy+th to oy+oh-1 do begin
      pBit2:=OutBMP.ScanLine[y];


      ///݂͉̓摜̍ʒuvZ
      //if zy<>iy+(l shr 8) then begin
      //   zy:=iy+(l shr 8);

         pBitN :=InBMP.ScanLine[zy-1];
         pBit:=InBMP.ScanLine[zy];
      //end;
      //oCjÅiYj
      l3:=(l-((l shr 16) shl 16))shr 8;//py


      asm
        push eax;push ebx;push ecx;push edx;push edi;push esi; // WX^ޔ

        //sNZʒu
        mov edi,pBit;//Src
        mov esi,pBitN;//Src+1
        mov ebx,pBit2;//Dest

        //JE^[B
        mov eax,ew;

        //ʒu𒲐B
        add ebx,ox4;


        //܂Ă̂́Aecx,edx
        mov ecx,ix8;//ʒu̐Έʒuƒl̕ێ

        //
        pxor mm6,mm6;
        movd mm7,iMM4;//mm7ɂ́A$00FF00FFB
        punpckldq mm7,mm7;//$00FF00FF 00FF00FFƃRs[Bdword>qword

        //܂́Aʏ̃[vłB
        @LOOP1:
         //擾ʒuwB

            //摜̈ʒuvZB
            mov edx,ecx;
            shr edx,16;

            //摜̃|C^ړ
            //摜̓(64rbǵB)
            movq mm2,qword ptr[edi+edx*4];
            movq mm3,qword ptr[esi+edx*4];
            movq mm0,mm2;
            movq mm1,mm3;

            //摜𐮓
            psrlq mm2,32;
            psrlq mm3,32;

            //QWORDɍLČvZł悤ɂB
            punpcklbw mm0,mm6;// a
            punpcklbw mm1,mm6;// b
            punpcklbw mm2,mm6;// c
            punpcklbw mm3,mm6;// d

            //PX̌vZBk-(zx shl 8);
            shl  edx,16;
            movd mm4,ecx;
            movd mm5,edx;
            psubd mm4,mm5;
            psrld mm4,8;

            //LĂ
            punpcklwd mm4,mm4;// $00aa > $00aa00aa
            punpckldq mm4,mm4;// $00aa00aa > $00aa00aa 00aa00aa
            movq  mm5,mm7;//]pmm7
            psubw mm5,mm4;//]B

	    //(px*py*(a+d-b-c) shr 8)+px*(b-a)+py*(c-a)) shr 8)+a;
            pmullw mm0, mm5; // a * px
            pmullw mm1, mm5; // c * px
            pmullw mm2, mm4; // b * (1 - px)
            pmullw mm3, mm4; // d * (1 - px)

            //PY̌vZBƂĂvZς݁B
            movd mm4,l3; // a_dy
            punpcklwd mm4,mm4; //[h_u[h
            punpckldq mm4,mm4; // 0x00bb00bb 00bb00bb
            movq mm5, mm7;//]pmm7
            psubw mm5,mm4;//]B

            //B
            paddusw mm0, mm2;  // (a * px + b * (1 - px))
            paddusw mm1, mm3;  // (c * px + d * (1 - px))
            psrlw mm0, 8;
            psrlw mm1, 8;
            pmullw mm0, mm5; // (a * px + b * (1 - px)) * py
            pmullw mm1, mm4; // (c * px + d * (1 - px)) * (1 - py)
            paddusw  mm0, mm1;  //
            psrlw    mm0, 8;
            packuswb mm0, mm6; // 0x00 00 00 00 B1' R0' G0' B0'

            //o͂̏
            movd dword ptr[ebx],mm0;
            add ebx,4;

            //K𑝂₷B
            add ecx,mzoomx;

            dec eax;

            jne @LOOP1;

        //E[̓ꃋ[vAB

        //JE^[B
        mov eax,ew2;

        //܂Ă̂́Aecx,edx
        //mov ecx,ix8_2;//ʒu̐Έʒuƒl̕ێ

        //߂
        sub ecx,mzoomx;

        @LOOP2:
         //擾ʒuwB

            //摜̈ʒuvZB
            mov edx,ecx;
            shr edx,16;

            //摜̃|C^ړ
            //摜̓(64rbǵB)
            movq mm0,qword ptr[edi+edx*4];
            movq mm1,qword ptr[esi+edx*4];
            movq mm2,mm0;
            movq mm3,mm1;

            //摜𐮓
            psrlq mm2,32;
            psrlq mm3,32;

            //QWORDɍLČvZł悤ɂB
            punpcklbw mm0,mm6;// a
            punpcklbw mm1,mm6;// c
            punpcklbw mm2,mm6;// b
            punpcklbw mm3,mm6;// d

            //PX̌vZBk-(zx shl 8);
            shl  edx,16;
            movd mm4,ecx;
            movd mm5,edx;
            psubd mm4,mm5;
            psrld mm4,8;

            //LĂ
            punpcklwd mm4,mm4;// $00aa > $00aa00aa
            punpckldq mm4,mm4;// $00aa00aa > $00aa00aa 00aa00aa
            movq  mm5,mm7;//]pmm7
            psubw mm5,mm4;//]B

	    //(px*py*(a+d-b-c) shr 8)+px*(b-a)+py*(c-a)) shr 8)+a;
            pmullw mm0, mm5; // a * px
            pmullw mm1, mm5; // c * px
            pmullw mm2, mm4; // b * (1 - px)
            pmullw mm3, mm4; // d * (1 - px)

            //PY̌vZBƂĂvZς݁B
            movd mm4,l3; // a_dy
            punpcklwd mm4,mm4; //[h_u[h
            punpckldq mm4,mm4; // 0x00bb00bb 00bb00bb
            movq mm5, mm7;//]pmm7
            psubw mm5,mm4;//]B

            //B
            paddusw mm0, mm2;  // (a * px + b * (1 - px))
            paddusw mm1, mm3;  // (c * px + d * (1 - px))
            psrlw mm0, 8;
            psrlw mm1, 8;
            pmullw mm0, mm5; // (a * px + b * (1 - px)) * py
            pmullw mm1, mm4; // (c * px + d * (1 - px)) * (1 - py)
            paddusw  mm0, mm1;  //
            psrlw    mm0, 8;
            packuswb mm0, mm6; // 0x00 00 00 00 B1' R0' G0' B0'

            //o͂̏
            movd dword ptr[ebx],mm0;
            add ebx,4;

            //K𑝂₷B
            add ecx,mzoomx;

            dec eax;

            jne @LOOP2;


        emms;
        pop esi;pop edi;pop edx;pop ecx;pop ebx;pop eax;    // WX^
      end;

      //ւ̈ʒu炷B
      l:=l+mzoomy;
  end;

end;


(*mCY𔭐*)
procedure EffectNoize(var SrcBitmap:TBitmap;noise:smallInt;const mode:shortInt);
var
 Row,Col,val,value  : Integer;
 DestRow,SrcRow     : pRGBArray;
 DestBitmap: TBitmap;
begin

 if(noise=0)then exit;

 DestBitmap:=TBitmap.Create;
 set32bit(SrcBitmap,DestBitmap);
 value:=noise*2+1;
 Randomize();

try
  //oomCY
  if(mode=2)then
  begin
   for Row:=0 to DestBitmap.Height-1 do
   begin
    DestRow:=DestBitmap.ScanLine[Row];
    SrcRow:=SrcBitmap.ScanLine[Row];
    for Col:=0 to DestBitmap.Width-1 do
     begin
      DestRow[Col].rgbBlue  :=RoundByte(SrcRow[Col].rgbBlue+random(value)-noise);
      DestRow[Col].rgbGreen :=RoundByte(SrcRow[Col].rgbGreen+random(value)-noise);
      DestRow[Col].rgbRed   :=RoundByte(SrcRow[Col].rgbRed+random(value)-noise);
     end;
   end;
   SrcBitmap.Handle :=DestBitmap.ReleaseHandle;
  end
  //PmCY
  else if(mode=1)then
  begin
   for Row:=0 to DestBitmap.Height-1 do
   begin
    DestRow:=DestBitmap.ScanLine[Row];
    SrcRow:=SrcBitmap.ScanLine[Row];
    for Col:=0 to DestBitmap.Width-1 do
     begin
      val:=random(value)-noise;
      DestRow[Col].rgbBlue  :=RoundByte(SrcRow[Col].rgbBlue+val);
      DestRow[Col].rgbGreen :=RoundByte(SrcRow[Col].rgbGreen+val);
      DestRow[Col].rgbRed   :=RoundByte(SrcRow[Col].rgbRed+val);
     end;
   end;
   SrcBitmap.Handle :=DestBitmap.ReleaseHandle;
  end;
except
  windows.MessageBox(0,'mCYG[','EffectMono',MB_OK);
end;

  DestBitmap.free;
end;

(*Nbv*)
procedure EffectClip(var SrcBitmap:TBitmap;Clip:TRect);
var
 h,w:Integer;
begin
 w:=Clip.Right-Clip.Left;
 h:=Clip.Bottom-Clip.Top;
 EffectResizeNormal(Clip.Left,Clip.Top,w,h,0,0,w,h,SrcBitmap,SrcBitmap);
 SrcBitmap.Width:=w;
 SrcBitmap.Height:=h;
end;

(*TCYύX*)
procedure EffectResize
 (Var srcBitmap:TBitmap;const width,height:Integer;smooth:boolean=false);
var
 DestBitmap: TBitmap;
begin

  DestBitmap:=TBitmap.Create;
  DestBitmap.PixelFormat:=pf32bit;
  DestBitmap.Width:=width;
  DestBitmap.Height:=height;
  if(smooth)then
   EffectResizeSmooth(0,0,srcBitmap.Width,srcBitmap.Height,
    0,0,width,height,srcBitmap,DestBitmap)
  else
   EffectResizeNormal(0,0,srcBitmap.Width,srcBitmap.Height,
    0,0,width,height,srcBitmap,DestBitmap);
  SrcBitmap.Handle:=DestBitmap.ReleaseHandle;

  DestBitmap.Free;
end;

procedure EffectThreadLine(var SrcBitmap:TBitmap;const effect:Integer=0);
var
 transcolor:DWORD;
 SrcColor:pRGBArray;
 odd:byte;
 Row,Col,len:Integer;
 rgb:TRGBQUAD;
const
 VERTICAL=1;
 HORIZON=2;
 MESH=3;
begin
              
 SrcBitmap.PixelFormat:=pf32bit;
 SrcBitmap.Canvas.Pen.Color:=SrcBitmap.Canvas.Pixels[0,0];

 case effect of
 VERTICAL:
 begin
  len:=SrcBitmap.Height;
  for Col:=0 to SrcBitmap.Width div 2 -1 do
  begin
   SrcBitmap.Canvas.MoveTo(2*Col,0);
   SrcBitmap.Canvas.LineTo(2*Col,len);
  end;
 end;

 HORIZON:
 begin
  len:=SrcBitmap.Width;
  for Row:=0 to SrcBitmap.Height div 2 -1 do
  begin
   SrcBitmap.Canvas.MoveTo(0,2*Row);
   SrcBitmap.Canvas.LineTo(len,2*Row);
  end
 end;

 MESH:
 begin

  odd:=SrcBitmap.Width mod 2;//
  transcolor:=SrcBitmap.Canvas.Pixels[0,0];
  rgb.rgbBlue:=(transcolor and $00ff0000) shr 16;
  rgb.rgbRed:=transcolor and $000000ff;
  rgb.rgbGreen:=(transcolor and $0000ff00)shr 8;

  len:=SrcBitmap.Width div 2;

  for Row:=0 to (SrcBitmap.Height div 2)-1 do
  begin


  SrcColor:=SrcBitmap.ScanLine[Row*2];


   for Col:=0 to len -1 do
   begin
    SrcColor[col*2]:=rgb;
   end;


   if(len>=(Row+1))then
   begin
    SrcColor:=SrcBitmap.ScanLine[Row*2+1];
    for Col:=0 to len -1+odd do
    begin
     SrcColor[col*2+1]:=rgb;
    end;


   end;

  end;


 end;

 end;
 // SrcBitmap.SaveToFile('sub.bmp');
end;

//K
procedure EffectMono(var SrcBitmap:TBitmap;value:smallInt);
var
 Row,Col            : Integer;
 SrcRow,DestRow     : pRGBArray;
 DestBitmap: TBitmap;
begin

 DestBitmap:=TBitmap.Create;
 set32bit(SrcBitmap,DestBitmap);

try
  for Row:=0 to DestBitmap.Height-1 do
  begin
      SrcRow:=SrcBitmap.ScanLine[Row];
      DestRow:=DestBitmap.ScanLine[Row];
      for Col:=0 to DestBitmap.Width-1 do
      begin
       if  (SrcRow[Col].rgbBlue <=Value) and
           (SrcRow[Col].rgbred <=Value) and
           (SrcRow[Col].rgbGreen <=Value) then
       begin
         DestRow[Col].rgbBlue  :=0;
         DestRow[Col].rgbGreen :=0;
         DestRow[Col].rgbRed   :=0;
       end
       else
       begin
         DestRow[Col].rgbBlue  :=255;
         DestRow[Col].rgbGreen :=255;
         DestRow[Col].rgbRed   :=255;
       end;
      end;
  end;
  SrcBitmap.Handle :=DestBitmap.ReleaseHandle;
except
  windows.MessageBox(0,'摜G[','EffectMono',MB_OK);
end;

  DestBitmap.free;
end;

//RGB`FW
procedure EffectShiftRGB(var SrcBitmap: TBitmap;mode:Integer);
var
  Row,Col         : Integer;
  SrcRow,DestRow  : pRGBArray;
  DestBitmap     : TBitmap;
const
 GBR=1;
 BRG=2;
 GR=3;
 BR=4;
 BG=5;
begin

  if(mode<1)or(mode>5)then exit;

  DestBitmap  :=TBitmap.Create;
  set32bit(SrcBitmap,DestBitmap);

  try
    for Row := 0 to SrcBitmap.Height - 1 do
    begin
      SrcRow  := SrcBitmap.Scanline[Row];
      DestRow := DestBitmap.Scanline[Row];

      for Col := 0 to SrcBitmap.Width - 1 do
      begin
       case mode of
        GBR:
        begin
         DestRow[Col].rgbRed   :=SrcRow[Col].rgbGreen;
         DestRow[Col].rgbGreen :=SrcRow[Col].rgbBlue;
         DestRow[Col].rgbBlue  :=SrcRow[Col].rgbRed;
        end;
        BRG:
        begin
         DestRow[Col].rgbRed   :=SrcRow[Col].rgbBlue;
         DestRow[Col].rgbGreen :=SrcRow[Col].rgbRed;
         DestRow[Col].rgbBlue  :=SrcRow[Col].rgbGreen;
        end;
        GR:
        begin
         DestRow[Col].rgbRed   :=SrcRow[Col].rgbGreen;
         DestRow[Col].rgbGreen :=SrcRow[Col].rgbRed;
         DestRow[Col].rgbBlue  :=SrcRow[Col].rgbBlue;
        end;
        BR:
        begin
         DestRow[Col].rgbRed   :=SrcRow[Col].rgbBlue;
         DestRow[Col].rgbBlue :=SrcRow[Col].rgbRed;
         DestRow[Col].rgbGreen   :=SrcRow[Col].rgbGreen;
        end;
        BG:
        begin
         DestRow[Col].rgbGreen   :=SrcRow[Col].rgbBlue;
         DestRow[Col].rgbBlue :=SrcRow[Col].rgbGreen;
         DestRow[Col].rgbRed :=SrcRow[Col].rgbRed;
        end;
       end;
     end;
    end;
     SrcBitmap.Handle :=DestBitmap.ReleaseHandle;
  except
   windows.MessageBox(0,'摜G[','ShiftRGB',MB_OK);
  end;

  DestBitmap.Free;
end;


 //邳
procedure EffectLightMode(var SrcBitmap: TBitmap;Value:Integer);
var
  Row,Col         : Integer;
  SrcRow,DestRow  : pRGBArray;
  DestBitmap     : TBitmap;
begin

  DestBitmap  :=TBitmap.Create;
  set32bit(SrcBitmap,DestBitmap);

  try
    for Row := 0 to SrcBitmap.Height - 1 do
    begin
      SrcRow  := SrcBitmap.Scanline[Row];
      DestRow := DestBitmap.Scanline[Row];
      for Col := 0 to SrcBitmap.Width - 1 do
      begin
          //eRGBValue𑫂
          DestRow[Col].rgbRed   :=RoundByte(SrcRow[Col].rgbRed+Value);
          DestRow[Col].rgbGreen :=RoundByte(SrcRow[Col].rgbGreen+Value);
          DestRow[Col].rgbBlue  :=RoundByte(SrcRow[Col].rgbBlue+Value) ;
      end;
    end;
     SrcBitmap.Handle :=DestBitmap.ReleaseHandle;
  except
   windows.MessageBox(0,'摜G[','lights',MB_OK);
  end;

  DestBitmap.Free;
end;


//ZsA
procedure EffectSepia(var SrcBitmap :TBitmap;effect:Integer=0);
var
  Row,Col           : Integer;
  SrcRow,DestRow    : pRGBArray;
  RGBColor          : BYTE;
  DestBitmap: TBitmap;
const
  tune:array[1..15, 0..2] of smallInt=
  ((0,0,0),(30,0,-30),(255,0,30),(255,0,0),
  (0,255,0),(0,0,255),(191,191,0),(191,0,191),(0,191,191),
  (0,-255,-255),(-255,0,-255),(-255,-255,0),(0,0,-255),
  (0,-255,0),(-255,0,0));

begin

  if(SrcBitmap=nil)or(effect>Length(tune))or(effect<1)then exit;

  DestBitmap   :=TBitmap.Create;
  set32bit(SrcBitmap,DestBitmap);

try
  for Row:=0 to SrcBitmap.Height-1 do
  begin
    SrcRow:=SrcBitmap.ScanLine[Row];
    DestRow:=DestBitmap.ScanLine[Row];
    for Col:=0 to SrcBitmap.Width-1 do
    begin
      //NTSCndϖ@păO[XP[
      RGBColor:=RoundByte(
                  (Round(SrcRow[Col].rgbRed   *0.289+
                         SrcRow[Col].rgbGreen *0.586+
                         SrcRow[Col].rgbBlue  *0.114 )));

      // F̃oX𒲐
      DestRow[Col].rgbRed  :=RoundByte(RGBColor +tune[effect,0]);
      DestRow[Col].rgbGreen:=RoundByte(RGBColor +tune[effect,1]);
      DestRow[Col].rgbBlue :=RoundByte(RGBColor +tune[effect,2]);
    end;
  end;
  SrcBitmap.Handle:=DestBitmap.ReleaseHandle;
except
 windows.MessageBox(0,'摜G[','colormap',MB_OK);
end;

  DestBitmap.Free();
end;


//E]
procedure EffectMirror(var SrcBitmap :TBitmap);
var
 Row,Col        : integer;
 SrcRow,DestRow : pRGBArray;
 DestBitmap     : TBitmap;
begin

 if(SrcBitmap=nil)then exit;
 DestBitmap  :=TBitmap.Create;

 set32bit(SrcBitmap,DestBitmap);

 Try
  for Row:=DestBitmap.Height-1 Downto 0 do
  begin
   SrcRow:=SrcBitmap.ScanLine[Row];
   DestRow:=DestBitmap.ScanLine[Row];

   for Col:=0 to DestBitmap.Width-1 do
   begin
    DestRow[Col]:=SrcRow[SrcBitmap.Width-Col-1];
   end;
  end;
 SrcBitmap.Handle:=DestBitmap.ReleaseHandle;
except
 windows.MessageBox(0,'摜G[','mirror',MB_OK);
end;

 DestBitmap.Free;
end;

//㉺]
procedure EffectFlip(var SrcBitmap :TBitmap);
var
  Row,Col            : Integer;
  SrcRow,DestRow     : PDWORDArray;
  DestBitmap  : TBitmap;
begin

  if(SrcBitmap=nil)then exit;

  DestBitmap  :=TBitmap.Create;
  set32bit(SrcBitmap,DestBitmap);
try
  for Row:=DestBitmap.Height-1 Downto 0 do
  begin
   SrcRow:=SrcBitmap.ScanLine[DestBitmap.Height-Row-1];
   DestRow:=DestBitmap.ScanLine[Row];

   for Col:=0 to DestBitmap.Width-1 do
   begin
    DestRow[Col]:=SrcRow[Col];
   end;
  end;

  SrcBitmap.Handle := DestBitmap.ReleaseHandle;
except
  windows.MessageBox(0,'摜G[','flip',MB_OK);
end;

 DestBitmap.Free;
end;

//G{X
procedure EffectEnbos(var SrcBitmap :TBitmap);
var
  Row,Col         : Integer;
  _Height,_Width  : integer;
  DestBitmap   : TBitmap;
  SrcRow,SrcRow2,DestRow : pRGBArray;
  Origin,Origin_RightUp,HogeRGB,X   : integer;
begin

 DestBitmap  :=TBitmap.Create;
 set32bit(SrcBitmap,DestBitmap);
 _Height := SrcBitmap.height-1;
 _Width  := SrcBitmap.width-1;

try
  if(SrcBitmap=nil)then exit;

    For Row := 0 To _Height   do
    begin
        SrcRow :=SrcBitmap.ScanLine[Row];

        //͈̓I[o[`FbN
        if Row<>_Height  then
         SrcRow2:=SrcBitmap.ScanLine[Row+1]
        else
         SrcRow2:=SrcBitmap.ScanLine[Row];
         DestRow:=DestBitmap.ScanLine[Row];

        For Col := 0 To _Width do
        begin
            //ȈYIQK擾
            Origin:= (SrcRow[Col].rgbRed+SrcRow[Col].rgbGreen+SrcRow[Col].rgbBlue) div 3;

            //͈̓I[o[`FbN
            if Col = _Width Then
                X := Col
            else
                X := Col + 1;

            //ȈYIQK擾(N_̉E)
            Origin_RightUp:= (SrcRow2[X].rgbRed+SrcRow2[X].rgbGreen+SrcRow2[X].rgbBlue) div 3;

            //G{X
            HogeRGB := -Origin + Origin_RightUp + 128;
            If HogeRGB < 0 Then  HogeRGB := 0  ;

            DestRow[Col].rgbBlue := HogeRGB;
            DestRow[Col].rgbGreen:= HogeRGB;
            DestRow[Col].rgbRed  := HogeRGB;
      end;
    end;

 SrcBitmap.Handle := DestBitmap.ReleaseHandle;
except
 windows.MessageBox(0,'摜G[','Enbos',MB_OK);
end;
 DestBitmap.free;
end;

//lK|W]
procedure EffectNOTMask(var srcBitmap: TBitmap);
var
  Row,Col          : Integer;
  SrcRow,DestRow   : pRGBArray;
  _Height,_Width   : integer;
  DestBitmap : TBitmap;
begin

 DestBitmap  :=TBitmap.Create;
 set32bit(SrcBitmap,DestBitmap);
 _Height := SrcBitmap.height-1;
 _Width  := SrcBitmap.width-1;

try

 if(SrcBitmap=nil)then exit;

   For Row := 0 To _Height   do
   begin
       SrcRow:=SrcBitmap.ScanLine[Row];
       DestRow:=DestBitmap.ScanLine[Row];
       For Col := 0 To _Width do
       begin
        DestRow[Col].rgbBlue := not SrcRow[Col].rgbBlue ;
        DestRow[Col].rgbGreen:= not SrcRow[Col].rgbGreen;
        DestRow[Col].rgbRed  := not SrcRow[Col].rgbRed ;
       end;
    end;
  SrcBitmap.handle :=DestBitmap.ReleaseHandle;
except
 windows.MessageBox(0,'摜G[','nega',MB_OK);
end;
  DestBitmap.Free;
end;

//gU
procedure EffectKakusan(var srcBitmap: TBitmap);
var
  Row,Col,hoge,foo: Integer;
  SrcRow,DestRow   : pRGBArray;
  DestBitmap : TBitmap;
begin

 DestBitmap  :=TBitmap.Create;
 SrcBitmap.Pixelformat:=pf32bit;
 DestBitmap.Assign(Srcbitmap);

try
   For Row := 0 To SrcBitmap.height-1   do
   begin
       //N_𒆐SɂĂ̕t߂_ŋ߂
       foo:=abs(Row-(Random(4))+2);
       if foo>SrcBitmap.height-1 then foo:=SrcBitmap.height-1
       else if foo<0 then foo:=0;

       SrcRow:=SrcBitmap.ScanLine[foo];
       DestRow:=DestBitmap.ScanLine[Row];

        For Col := 0 To SrcBitmap.Width-1 do
        begin
           //N_𒆐SɂĂ̕t߂_ŋ߂
           hoge:=abs(Col-(Random(4))+2);
           if hoge>SrcBitmap.Width-1 then hoge:=SrcBitmap.Width-1
           else if hoge<0 then hoge:=0;

           DestRow[Col]:=SrcRow[hoge];

       end;
    end;
  SrcBitmap.Handle :=DestBitmap.ReleaseHandle;
except
 windows.MessageBox(0,'摜G[','spread',MB_OK);
end;

  DestBitmap.Free;
end;


//lȉ摜C
procedure EffectCustom(var SrcBitmap: TBitmap;masktype:Integer);
var
  Row,Col,yRow,xCol,r,g,b,X,y,EAX: Integer;
  DestRow          : pRGBArray;
  SourceBits       : PPBits;
  _Height,_Width   : integer;
  DestBitmap  : TBitmap;
  MaskBits : array[0..8] of Smallint;
  Divisor,Bias:byte;
begin

 if(SrcBitmap=nil)then exit;

 case masktype of
  1:
  begin //ڂ
   Bias:=0;
   Divisor:=9;
   MaskBits[0]:= 1;   MaskBits[1]:= 1;   MaskBits[2]:= 1;
   MaskBits[3]:= 1;   MaskBits[4]:= 1;   MaskBits[5]:= 1;
   MaskBits[6]:= 1;   MaskBits[7]:= 1;   MaskBits[8]:= 1;
  end;
  2:
  begin //V[v
   Bias:=0;
   Divisor:=16;
   MaskBits[0]:= -1;  MaskBits[1]:= -1;   MaskBits[2]:= -1;
   MaskBits[3]:= -1;  MaskBits[4]:= 24;   MaskBits[5]:= -1;
   MaskBits[6]:= -1;  MaskBits[7]:= -1;   MaskBits[8]:= -1;
  end;
  3:
  begin //Tp[
   Bias:=0;
   Divisor:=16;
   MaskBits[0]:= 1;   MaskBits[1]:= 3;   MaskBits[2]:= 1;
   MaskBits[3]:= 3;   MaskBits[4]:= 5;   MaskBits[5]:= 3;
   MaskBits[6]:= 1;   MaskBits[7]:= 3;   MaskBits[8]:= 1;
  end;
  4:
  begin //J[G{X
   Divisor:=1; Bias:=0;
   MaskBits[0]:= -1;   MaskBits[1]:= -1;   MaskBits[2]:=-1;
   MaskBits[3]:= 0;    MaskBits[4]:= 1;    MaskBits[5]:= 0;
   MaskBits[6]:= 1;    MaskBits[7]:= 1;    MaskBits[8]:= 1;
  end;
  5:
  begin
   //_[NG{X
   Divisor:=1; Bias:=128;
   MaskBits[0]:= -1;    MaskBits[1]:= -2;   MaskBits[2]:= -1;
   MaskBits[3]:=  0;    MaskBits[4]:=  0;   MaskBits[5]:=  0;
   MaskBits[6]:=  1;    MaskBits[7]:=  2;   MaskBits[8]:=  1;
  end;
  6:
  begin
   //GNgJ
   Divisor:=1; Bias:=0;
   MaskBits[0]:=  1;    MaskBits[1]:=  1;   MaskBits[2]:=  1;
   MaskBits[3]:=  1;    MaskBits[4]:=-15;   MaskBits[5]:=  1;
   MaskBits[6]:=  1;    MaskBits[7]:=  1;   MaskBits[8]:=  1;
  end;
  else
  begin
   exit;
  end;
 end;

 DestBitmap  :=TBitmap.Create;
 set32bit(SrcBitmap,DestBitmap);
 _Height := SrcBitmap.height-1;
 _Width  := SrcBitmap.width-1;

   GetMem(SourceBits, SrcBitmap.Height * SizeOf(pRGBArray));
try
   for Row:= 0 to SrcBitmap.Height - 1 do  SourceBits[Row]:=SrcBitmap.Scanline[Row];

   For Row := 0 To _Height   do
   begin

        DestRow:=DestBitmap.ScanLine[Row];

        For Col := 0 To _Width do
        begin
            //-------------
            // 0 - 1 - 2
            //-------------
            // 3 - 4 - 5
            //-------------
            // 6 - 7 - 8
            //-------------
            R:=0;G:=0;B:=0; EAX:=0;
            for y:= -1 to 1 do
            begin
              for x:= -1 to 1 do
              begin
                 //Y
                 if      Row+(y)> _Height then
                  yRow:=_Height
                 else if Row+(y)< 0       then
                  yRow:=0
                 else
                   yRow:=Row+(y);
                 //X
                 if      Col+(x)> _Width  then  xCol:=_Width
                 else if Col+(x)< 0       then  xCol:=0
                 else
                   xCol:=Col+(x);

                 B:=B+(SourceBits[yRow][xCol].rgbBlue*MaskBits[EAX]);
                 G:=G+(SourceBits[yRow][xCol].rgbGreen*MaskBits[EAX]);
                 R:=R+(SourceBits[yRow][xCol].rgbRed*MaskBits[EAX]);
                 inc(EAX);
              end;
            end;

         //  DestRow[col].rgbReserved:=SourceBits[yRow][xCol].rgbReserved;
           DestRow[Col].rgbRed   :=RoundByte((R div Divisor)+Bias);
           DestRow[Col].rgbGreen :=RoundByte((G div Divisor)+Bias);
           DestRow[Col].rgbBlue  :=RoundByte((B div Divisor)+Bias);

       end;
    end;

  FreeMem(SourceBits); SourceBits:=nil;
  SrcBitmap.handle :=DestBitmap.ReleaseHandle;

  except
     if Assigned(SourceBits) then FreeMem(SourceBits);
    windows.MessageBox(0,'摜G[','EffectCustom',MB_OK); 
  end;

  DestBitmap.Free;
end;





end.


