unit ExtAllowedForms;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons ,types;

type

  TAllowedExt = (aeNone,aeBmp,aeJpg,aeJpy1,aeJptx,aeJpdc,aeWave);
  TAllowedExtArray = array[aeBmp..aeWave] of boolean;

  TFileAllowedFilter = class(TObject)
   fileAllowed:TAllowedExtArray;
   constructor create();
   function getAllowed(index:TAllowedExt):boolean;
   procedure setAllowed(allowed:boolean;index:TAllowedExt);
  end;

  TExtAllowedForm = class(TForm)
    JPY1CB: TCheckBox;
    JPTXCB: TCheckBox;
    JPDCCB: TCheckBox;
    BMPCB: TCheckBox;
    JPGCB: TCheckBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    WAVCB: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    function createAllowedFilter():TFileAllowedFilter;
  end;

var
  ExtAllowedForm: TExtAllowedForm;

//const
//  aeLength=6;

implementation

{$R *.dfm}

function TFileAllowedFilter.getAllowed(index:TAllowedExt):boolean;
begin
 result:=fileAllowed[index];
end;

procedure TExtAllowedForm.BitBtn1Click(Sender: TObject);
begin
 ModalResult := mrOK;
end;

procedure TExtAllowedForm.BitBtn2Click(Sender: TObject);
begin
 ModalResult := mrCancel;
end;

function TExtAllowedForm.createAllowedFilter():TFileAllowedFilter;
begin
 result:=TFileAllowedFilter.create();
 result.setAllowed(JPDCCB.Checked,aejpdc);
 result.setAllowed(JPY1CB.Checked,aejpy1);
 result.setAllowed(BMPCB.Checked,aebmp);
 result.setAllowed(JPGCB.Checked,aejpg);
 result.setAllowed(JPTXCB.Checked,aejptx);
 result.setAllowed(WAVCB.Checked,aewave);
end;

{}
procedure TFileAllowedFilter.setAllowed(allowed:boolean;index:TAllowedExt);
begin

 if(index<>aeNone)then
 begin
  fileAllowed[index]:=allowed;
 end;

end;

constructor TFileAllowedFilter.create();
var
 i:TAllowedExt;
begin

 {for i:=aeNone to aeJpdc do
 begin
  fileAllowed[i]:=true;
  Application.MessageBox(PChar(IntToStr(Ord(i))),'');
 end;
  }

 fileAllowed[aeJpdc]:=true;
 fileAllowed[aejpg]:=true;
 fileAllowed[aebmp]:=true;
 fileAllowed[aejpy1]:=true;
 fileAllowed[aejptx]:=true;
 fileAllowed[aewave]:=false;
end;


end.
