unit JPTXForms;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpxheader, StdCtrls, Buttons,textForms,ImageForms,ShellAPI;

type
  TJPTXMaker = class(TForm)
    loadBB: TBitBtn;
    OpenDialog1: TOpenDialog;
    JPXFrame1: TJPXFrame;
    BitBtn1: TBitBtn;
    SaveDialog1: TSaveDialog;
    reNewBB: TBitBtn;
    procedure loadBBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure reNewBBClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure JPXFrame1BitBtn3Click(Sender: TObject);
    procedure JPXFrame1Button1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure DropFile(var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure loadFile(fileName:string);
  public
    { Public 錾 }
   imageForm:TImageForm;
   memoForm:TMemoForm;
  end;

var
  JPTXMaker: TJPTXMaker;

implementation

{$R *.dfm}

procedure TJPTXMaker.loadBBClick(Sender: TObject);
var
 bitmap:TBitmap;
begin
 if(OpenDialog1.Execute)then
 begin
  self.loadFile(OpenDialog1.FileName);
 { JPXFrame1.loadJPX(self.OpenDialog1.FileName);
  bitmap:=JPXFrame1.viewBitmap;
  if(Bitmap=nil)then windows.MessageBox(0,'','',MB_OK);

  imageForm.Hide();
  imageForm.Image1.Canvas.Brush.Color:=not(bitmap.Canvas.Brush.Color);
  imageForm.Image1.Canvas.FillRect(imageForm.Image1.ClientRect);
  bitblt(imageForm.Image1.Canvas.Handle,0,0,bitmap.Width,bitmap.Height,
   bitmap.Canvas.Handle,0,0,srcCopy);
  memoForm.setStrings(JPXFrame1.tagLines);
  memoForm.Show();
  imageForm.Show();
  Caption:='JPTXMaker - '+OpenDialog1.FileName;   }
 end;
end;

procedure TJPTXMaker.FormCreate(Sender: TObject);
begin
 self.memoForm:=TMemoForm.Create(self);
 self.imageForm:=TImageForm.Create(self);
 DragAcceptFiles(self.Handle, True);
end;

procedure TJPTXMaker.FormDestroy(Sender: TObject);
begin
 self.memoForm.Free();
 self.imageForm.Free();
end;

procedure TJPTXMaker.reNewBBClick(Sender: TObject);
var
 bitmap:TBitmap;
 color:TColor;
begin
 JPXFrame1.makeJPX(MemoForm.getStrings,JPXFrame1.getJInf);
 bitmap:=JPXFrame1.viewBitmap;


 color:=bitmap.Canvas.Brush.Color;
 imageForm.Image1.Canvas.Brush.Color:=(color xor $ffffff);
 imageForm.Image1.Canvas.FillRect(imageForm.Image1.ClientRect);

 bitblt(imageForm.Image1.Canvas.Handle,0,0,bitmap.Width,bitmap.Height,
  bitmap.Canvas.Handle,0,0,srcCopy);

 if not(self.memoForm.Visible)then self.memoForm.Show;
 if not(self.imageForm.Visible)then self.imageForm.Show;

end;

procedure TJPTXMaker.BitBtn1Click(Sender: TObject);
begin

 if(SaveDialog1.Execute)then
 begin
  SaveDialog1.FileName:=changeFileExt(SaveDialog1.FileName,'.jptx');
  JPXFrame1.tagLines.Assign(MemoForm.getStrings);
  JPXFrame1.saveJPX(SaveDialog1.FileName);
 end;

end;

procedure TJPTXMaker.loadFile(fileName:string);
var
 bitmap:TBitmap;
begin
 JPXFrame1.loadJPX(FileName);
 bitmap:=JPXFrame1.viewBitmap;
 if(Bitmap=nil)then windows.MessageBox(0,'','',MB_OK);

 imageForm.Hide();
 imageForm.Image1.Canvas.Brush.Color:=not(bitmap.Canvas.Brush.Color);
 imageForm.Image1.Canvas.FillRect(imageForm.Image1.ClientRect);
 bitblt(imageForm.Image1.Canvas.Handle,0,0,bitmap.Width,bitmap.Height,
  bitmap.Canvas.Handle,0,0,srcCopy);
 memoForm.setStrings(JPXFrame1.tagLines);
 memoForm.Show();
 imageForm.Show();
 Caption:='JPTXMaker - '+OpenDialog1.FileName;

end;

procedure TJPTXMaker.DropFile(var Msg:TWMDROPFILES);
var
  FileName: array [0..255] of Char;
begin

  DragQueryFile(Msg.Drop, 0, FileName, SizeOf(FileName)-1);

  if('.jptx'=ExtractFileExt(fileName))then
   loadFile(fileName);

  DragFinish(Msg.Drop);
end;

procedure TJPTXMaker.JPXFrame1BitBtn3Click(Sender: TObject);
begin
  JPXFrame1.BitBtn3Click(Sender);
end;

procedure TJPTXMaker.JPXFrame1Button1Click(Sender: TObject);
begin
  JPXFrame1.Button1Click(Sender);

end;

end.
