unit SDIMAIN;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus, SySutils,
  StdCtrls, ComCtrls, ShellCtrls, Dialogs, ImgList, StdActns,Clipbrd,
  Buttons, ExtCtrls,shellAPI,ShlObj, initFrames, ToolWin, ExtDlgs, ActnList,
 ViewForms,convImages,FileCtrl,iniFiles,TextImages,messages;

type
  TJPYMaker = class(TForm)
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    ToolBar1: TToolBar;
    ToolButton9: TToolButton;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    copyTB: TToolButton;
    ToolButton6: TToolButton;
    ActionList1: TActionList;
    FileNew1: TAction;
    FileOpen1: TAction;
    FileSave1: TAction;
    FileSaveAs1: TAction;
    FileExit1: TAction;
    EditCut1: TAction;
    EditCopy1: TAction;
    EditPaste1: TAction;
    HelpAbout1: TAction;
    StatusBar: TStatusBar;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    Edit1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    Help1: TMenuItem;
    HelpAboutItem: TMenuItem;
    entryBitBtn: TBitBtn;
    Image1: TImage;
    PartsEdit: TEdit;
    ListView1: TListView;
    initFrame2: TinitFrame;
    folderSelectCB: TComboBox;
    backBitBtn: TBitBtn;
    ClearBitBtn: TBitBtn;
    Show1: TMenuItem;
    EditShow: TAction;
    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure FileSave1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure entryBitBtnClick(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure folderSelectCBChange(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure copyTBClick(Sender: TObject);
    procedure FileSaveFirstExecute(Sender: TObject);
    procedure backBitBtnClick(Sender: TObject);
    procedure ClearBitBtnClick(Sender: TObject);
    procedure EditShowExecute(Sender: TObject);
  private
    { Private 錾 }
    folderINum,bmpINum,jpegINum,jpxINum,dircount:Integer;
    jpyINum,jpwINum:Integer;
    depth:smallInt;
    lock,select,isSummary:boolean;
    director:TEDDirector;
    baseName,scenarioName,pathName,middlePath,nowFileName:string;
    selectFileName,openFileName:string;
    selectPosInf:TPosInf;
    selectDirtype:Integer;
    procedure WMDROPFILES(var msg:TWMDROPFILES);message WM_DROPFILES;
    procedure saveJPY(fileName:string);
    procedure openFolder(dirName:string);
    procedure loadJPY(FileName:string);
    function getDirtype():shortInt;
    function getFileName():string;
    function setIcon(fileName:string):Integer;
    function IsSendPartsAllowed():boolean;
  public
    { Public 錾 }
    ViewForm:TViewForm;
    baseBitmap,arrangedBitmap:TBitmap;
    procedure reset();
    procedure receiveInf(inf:TImageInfo);
    procedure receiveParts(inf:TImageInfo);
    procedure setImageFileList(folderName:string);
  end;



var
  JPYMaker: TJPYMaker;

const
  sjScenario=4;
  sjCurrent=1;
  sjTable=2;
  sjScheme=3;


implementation

uses about;

{$R *.dfm}

procedure TJPYMaker.reset();
begin
 initFrame2.reset();
 ViewForm.reset();
 ListView1.ItemIndex:=-1;
 self.dircount:=-1;
 self.depth:=0;
 Image1.Canvas.FillRect(Image1.ClientRect);
 arrangedBitmap.Canvas.FillRect(arrangedBitmap.Canvas.ClipRect);
 baseBitmap.Canvas.FillRect(baseBitmap.Canvas.ClipRect);
end;

procedure TJPYMaker.FileNew1Execute(Sender: TObject);
var
 dirName:string;
begin
  if not(DirectoryExists(baseName+'\Scenario'))then
   CreateDir(baseName+'\Scenario');
  if(selectDirectory('fBNg̑I',baseName+'\Scenario',dirName))then
   if (fileExists(dirName+'\Summary.wsm'))then
   begin
    isSummary:=true;
    nowFileName:='';
    select:=false;
    openFolder(dirName);
   end
   else if (Application.MessageBox('ViItH_ł͂܂񂪍\܂񂩁H',
   'mF',MB_YESNO)=6)then
  begin
   nowFileName:='';
   select:=false;
   openFolder(dirName);
   isSummary:=false;
  end;
end;

(*摜ptH_J*)
procedure TJPYMaker.openFolder(dirName:string);
begin
 self.lock:=true;
 self.reset();
 self.scenarioName:=dirName;
 self.pathName:=dirName;
 setImageFileList(scenarioName);
 folderSelectCB.Items.Strings[2]:=ExtractFileName(pathName);
 folderSelectCB.ItemIndex:=2;
 entryBitBtn.Enabled:=true;
 backBitBtn.Enabled:=true;
 clearBitBtn.Enabled:=true;
 ToolButton2.Enabled:=true;
 lock:=false;
 if(ListView1.Items.Count>1)then
  ListView1.ItemIndex:=0;
end;

(*t@CI*)
procedure TJPYMaker.FileOpen1Execute(Sender: TObject);
begin

 if(OpenDialog.Execute)then
  loadJPY(OpenDialog.FileName);

end;

(*ݒt@Cɕۑ*)
procedure TJPYMaker.saveJPY(fileName:string);
var
 init:TIniFile;
 secList:TStringList;
 inf:TImageInfo;
 i,v:Integer;
begin
  init:=TIniFile.Create(fileName);
  secList:=TStringList.Create();
 try

  init.ReadSections(secList);

  v:=secList.IndexOf('init');
  if(v>-1)then
   secList.Delete(v);

  (*]vȃZNV폜*)
  for i:=0 to secList.Count-1 do
  begin
   v:=ViewForm.PartsListBox.Items.IndexOf(secList.Strings[i]);
   if(v=-1)then init.EraseSection(secList.Strings[i]);
  end;

  inf:=ViewForm.getInitInf();
  inc(inf.delCount);
  director.writeInitSection(TCustomIniFile(init),inf);
  inf.FreeEx();

  for i:=0 to ViewForm.PartsListBox.Items.Count-1 do
  begin
   director.writeSection
   (TCustomIniFile(init),ViewForm.getSectionInf(i));
  end;
  init.UpdateFile();
 finally
  init.Free();
  secList.Free();
 end;
end;


(*ݒt@Cۑ*)
procedure TJPYMaker.FileSaveFirstExecute(Sender: TObject);
begin
 if(SaveDialog.Execute)then
 begin
  case saveDialog.FilterIndex of
   1:
   begin
    SaveDialog.FileName:=ChangeFileExt(SaveDialog.FileName,'.jpy');
    saveJPY(SaveDialog.FileName);
    nowFileName:=SaveDialog.FileName;
   end;
   2:
   begin
    SaveDialog.FileName:=ChangeFileExt(SaveDialog.FileName,'.bmp');
    ViewForm.saveImage(SaveDialog.FileName);
   end;
  end;

 end;


end;

procedure TJPYMaker.FileSave1Execute(Sender: TObject);
begin
 if(FileExists(nowFileName))then
 begin
  try
   saveJPY(nowFileName);
  except
   windows.MessageBox(0,'',PCHar(self.nowFileName),MB_OK);
  end;
 end
 else
  self.FileSaveFirstExecute(Sender);
end;

procedure TJPYMaker.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

procedure TJPYMaker.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TJPYMaker.FormCreate(Sender: TObject);
var
  c:array[0..255] of char;
begin
  basename:=ExtractFileDir(Application.ExeName);
  baseBitmap:=TBitmap.Create();
  baseBitmap.PixelFormat:=pf32bit;
  isSummary:=false;
  arrangedBitmap:=TBitmap.Create();
  arrangedBitmap.PixelFormat:=pf32bit;
  DragAcceptFiles(self.Handle, True);

  initFrame2.NotifyArrangeEvent:=self.receiveInf;
  windows.GetSystemDirectory(c,255);
  folderINum:=self.setIcon(c);
  bmpINum:=-1;
  jpegINum:=-1;
  jpxINum:=-1;
  jpyINum:=-1;
  jpwINum:=-1;
  ViewForm:=TViewForm.Create(self.Owner);
  ViewForm.NotifySeekEvent:=self.receiveParts;
  director:=TEDDirector.create();
  ViewForm.Show();

  select:=False;
   // SHGetFileInfo(c,0,FileInfo,sizeof(FileInfo),
 //  SHGFI_ICON or SHGFI_SMALLICON or SHGFI_OPENICON);
end;

(*ǂݍ񂾉摜t[ɓo^*)
procedure TJPYMaker.entryBitBtnClick(Sender: TObject);
var
 inf:TImageInfo;
begin

 if(self.IsSendPartsAllowed)and(PartsEdit.Text<>'init')then
 begin

  inf:=initFrame2.getImageInfo();
  inc(inf.delCount);
  if(self.select)then
  begin
   inf.sectionName:=PartsEdit.Text;
   inf.fileName:=self.selectFileName;
   inf.posInf:=self.selectPosInf;
   inf.dirtype:=self.selectDirtype;
  end
  else
  begin
   inf.dirtype:=getDirtype();
   inf.fileName:=getFileName();
   inf.posInf.w:=arrangedBitmap.Width;
   inf.posInf.h:=arrangedBitmap.Height;
   inf.sectionName:=PartsEdit.Text;
  end;

  inc(inf.delCount);
  ViewForm.add(inf,arrangedBitmap);

  viewForm.Show();
  inf.FreeEx();
  
 end
 else windows.MessageBeep(0);  
end;

(*Xgp̃~jACR쐬*)
function TJPYMaker.setIcon(fileName:string):Integer;
var
 icon:TIcon;
 FileInfo: TSHFileInfo;
begin

 icon:=TIcon.Create();
 icon.Width:=16;
 icon.Height:=16;

 SHGetFileInfo(PChar(fileName)
 ,0,FileInfo,sizeof(FileInfo),SHGFI_ICON or SHGFI_SMALLICON);

 icon.Handle:=fileInfo.hIcon;

 result:=ImageList1.AddIcon(icon);


end;

(*pX摜ꗗ擾*)
procedure TJPYMaker.setImageFileList(folderName:string);
var
 SR:TSearchRec;
 ExtName:string;
 Found:Integer;
 listItem:TListItem;
begin

 lock:=true;

 with self.ListView1.Items do
 begin

  Found:=FindFirst(folderName+'\*.*',faDirectory,SR);
  BeginUpdate();
  Clear();
  dircount:=-1;
  ExtName:='';

 (*tH_Ɖ摜t@C𕪊ĕ\*)
  try
   while Found = 0 do
   begin

   if((SR.Attr and faDirectory)<>0) and(SR.Name<>'.')then
   begin
    if(SR.Name='..')and(depth<1)then
    begin
     Found:=FindNext(SR);
     continue;
    end;
    inc(dircount);
    listItem:=Insert(dircount);
    listItem.ImageIndex:=folderINum;
    listItem.Caption:=SR.Name;
   end
   else
   begin
    ExtName:=AnsiLowerCase(ExtractFileExt(SR.Name));
    if(ExtName='.bmp')then
    begin

     if(bmpINum=-1)then
      bmpINum:=self.setIcon(folderName+'\'+SR.Name);

     listItem:=Add();
     listItem.ImageIndex:=bmpINum;
     listItem.Caption:=SR.Name;
    end
    else if(ExtName='.jpg')or(ExtName='.jpeg')then
    begin
     if(jpegINum=-1)then
      jpegINum:=self.setIcon(folderName+'\'+SR.Name);

     listItem:=Add();
     listItem.ImageIndex:=jpegINum;
     listItem.Caption:=SR.Name;
    end
    else if(ExtName='.jpx')or(ExtName='.jpw')then
    begin
     if(jpxINum=-1)then
      jpxINum:=self.setIcon(folderName+'\'+SR.Name);

     listItem:=Add();
     listItem.ImageIndex:=jpxINum;
     listItem.Caption:=SR.Name;
    end
    else if(ExtName='.jpy')then
    begin
     if(folderName+'\'+SR.Name<>openFileName)then
     begin
      if(jpyINum=-1)then
       jpyINum:=self.setIcon(folderName+'\'+SR.Name);

      listItem:=Add();
      listItem.ImageIndex:=jpyINum;
      listItem.Caption:=SR.Name;
     end;
    end
    else if(ExtName='.jpw')then
    begin
     if(jpwINum=-1)then
      jpwINum:=self.setIcon(folderName+'\'+SR.Name);

     listItem:=Add();
     listItem.ImageIndex:=jpwINum;
     listItem.Caption:=SR.Name;
    end;
   end;

   Found:=FindNext(SR);
  end;
  finally
   sysUtils.FindClose(SR);
  end;

   EndUpdate();
 end;

  if(ListView1.Items.Count>1)then
   ListView1.ItemIndex:=0;

  lock:=false
end;

(*Xg摜ǂݍ*)
procedure TJPYMaker.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var
 ext:string;
 inf:TImageInfo;
begin
 if not(lock)and FileExists(pathName+'\'+item.Caption)then
 begin
 ext:=AnsiLowercase(ExtractFileExt(item.Caption));
 if(ext='.bmp')or(ext='.jpg')or(ext='.jpeg')or(ext='.jpx')
  or(ext='.jpy')or(ext='.jpw')then
  begin
   director.loadImage(pathName+'\'+item.Caption,baseBitmap);
   inf:=initFrame2.getImageInfo();
   inc(inf.delCount);
   receiveInf(inf);
   inf.FreeEx();
   select:=false;
  end
 end
 else Image1.Canvas.FillRect(Image1.Canvas.ClipRect);
end;

(*iniFrame̕ω󂯎*)
procedure TJPYMaker.receiveInf(inf:TImageInfo);
begin
 self.arrangedBitmap.Assign(self.baseBitmap);
 inc(inf.delCount);
 convImages.customizeBitmap(inf,arrangedBitmap);
 Image1.Canvas.CopyRect(Image1.Canvas.ClipRect,
  arrangedBitmap.Canvas,arrangedBitmap.Canvas.ClipRect);
 inf.FreeEx(); 
end;

(*viewForm̑I󂯎*)
procedure TJPYMaker.receiveParts(inf:TImageInfo);
var
 dinf:TDirInf;
 fileName:string;
 oldColor:TColor;
begin

 dinf.fileName:=inf.fileName;
 dinf.mode:=inf.dirtype;
 dinf.currentFile:=scenarioName;
 dinf.firstDir:=scenarioName;
 dinf.exeDir:=baseName;
 fileName:=TTagText.serachFileName(dinf);

 if(FileExists(fileName))then
  director.loadImage(fileName,baseBitmap)
 else
 begin
  oldColor:=baseBitmap.Canvas.Brush.Color;
  baseBitmap.Canvas.Brush.Color:=inf.color;
  baseBitmap.Canvas.FillRect(baseBitmap.Canvas.ClipRect);
  baseBitmap.Canvas.Brush.Color:=oldColor;
 end;

 if(inf.posInf.w=-1)then
  if(inf.needClip)then
   inf.posInf.w:=inf.clip.Right-inf.clip.Left
  else
   inf.posInf.w:=baseBitmap.Width;

 if(inf.posInf.h=-1)then
  if(inf.needClip)then
   inf.posInf.w:=inf.clip.Bottom-inf.clip.Top
  else
   inf.posInf.h:=baseBitmap.Height;

 arrangedBitmap.Assign(baseBitmap);
 self.initFrame2.lock:=true;
 inc(inf.delCount);
 self.initFrame2.setImageInfo(inf);
 self.initFrame2.lock:=false;
 inc(inf.delCount);
 customizeBitmap(inf,arrangedBitmap);

 self.selectFileName:=inf.fileName;
 self.selectDirtype:=inf.dirtype;
 self.selectPosInf:=inf.posInf;
 PartsEdit.Text:=inf.sectionName;

 Image1.Canvas.StretchDraw(Image1.Canvas.ClipRect,arrangedBitmap);

 select:=true;
 inf.FreeEx();
 self.Show();

end;


(*ǂ̃^CṽtH_JI*)
procedure TJPYMaker.folderSelectCBChange(Sender: TObject);
begin

 case self.folderSelectCB.ItemIndex of
  0:
   begin
    if not(DirectoryExists(baseName+'\data\table'))then
    begin
     CreateDir(baseName+'\data\table');
    end;
     pathName:=baseName+'\data\table';
     self.depth:=0;
     middlePath:='';
     setImageFileList(pathName);
   end;
  1:
   begin
    if not(DirectoryExists(baseName+'\Scheme'))then
    begin
     CreateDir(baseName+'\Scheme');
    end;
     pathName:=baseName+'\Scheme';
     self.depth:=0;
     middlePath:='';
     setImageFileList(pathName);
   end;
  2:
  begin
   if(scenarioName<>'')then
   begin
    pathName:=scenarioName;
    middlePath:='';
    setImageFileList(pathName);
   end
   else self.ListView1.Clear();
   end;
  end;

end;

 (*tH_IƃTutH_J*)
procedure TJPYMaker.ListView1DblClick(Sender: TObject);
var
 dirName:string;
begin
 if(ListView1.ItemIndex>-1)and(ListView1.ItemIndex<=self.dircount)then
 begin
  dirName:=ListView1.Items.Item[ListView1.ItemIndex].Caption;

  if(dirName='..')then
  begin
   dec(depth);
   middlePath:=ExtractFileDir(middlePath);
   PathName:=ExtractFileDir(pathName);
  end
  else
  begin
   if(middlePath='')then
    middlePath:=dirName
   else
    middlePath:=middlePath+'\'+dirName;

   pathName:=pathName+'\'+dirName;
   inc(depth);
  end;

  lock:=true;
  setImageFileList(pathName);
  lock:=false;
  ListView1.ItemIndex:=0;
 end;

end;

procedure TJPYMaker.FormDestroy(Sender: TObject);
begin
 director.Free();
// if(self.lastImageInf<>nil)then self.lastImageInf.Free();
end;

procedure TJPYMaker.copyTBClick(Sender: TObject);
var
 h:HWND;
begin
 h:=getActiveWindow();

 if(h=ViewForm.Handle)then
  self.ViewForm.saveImage('',2)
 else if(h=self.Handle)then
  ClipBoard.Assign(arrangedBitmap);
  

 
end;

function TJPYMaker.IsSendPartsAllowed():boolean;
begin
 result:=(select)
  or((PartsEdit.Text<>'')and(ListView1.ItemIndex>dircount)
  and(arrangedBitmap.Width*arrangedBitmap.Height<>0));
end;

procedure TJPYMaker.backBitBtnClick(Sender: TObject);
var
 bitmap:TBitmap;
 fileName,subfileName:string;
 dirtype:shortInt;
begin

 subfileName:=ListView1.Items.Item[ListView1.ItemIndex].Caption;
 fileName:=pathName+'\'+subFileName;
 //windows.MessageBox(0,PChar(pathName),PChar(),MB_OK);

 if(FileExists(fileName))then
 begin
  dirtype:=getDirtype();
  bitmap:=TBitmap.Create();
  director.loadImage(fileName,bitmap);
  ViewForm.setInitImage(dirtype,getFileName(),bitmap);
  viewForm.Show();
  bitmap.Free();
 end;
 
end;

function TJPYMaker.getDirtype():shortInt;
begin
  if(select)then result:=selectDirtype
  else
  case folderSelectCB.ItemIndex of
   0:result:=sjTable;
   1:result:=sjScheme;
   2:if(isSummary)then result:=sjScenario
     else result:=sjCurrent;
   else result:=-1;
  end;
end;

function TJPYMaker.getFileName():string;
begin
  if(ListView1.Selected<>nil)then
  begin
   if(middlePath='')then
    result:=ListView1.Items.Item[ListView1.ItemIndex].Caption
   else
    result:=middlePath+'\'+ListView1.Items.Item[ListView1.ItemIndex].Caption;
  end
  else result:='';
end;
  {
function TJPYMaker.getFilePath():string;
begin
  if(select)then result:=ExtractFileDir(selectFileName)
  else
   result:=pathName;
end;
   }
procedure TJPYMaker.ClearBitBtnClick(Sender: TObject);
begin
 ViewForm.setInitImage(-1,'',nil);
 viewForm.Show();
end;

procedure TJPYMaker.EditShowExecute(Sender: TObject);
begin
 ViewForm.Visible:=not ViewForm.Visible;
end;

procedure TJPYMaker.WMDROPFILES(var msg:TWMDROPFILES);
var
  FileName: array [0..255] of Char;
begin
//  DropFileCount := DragQueryFile(Msg.Drop, Cardinal(-1), nil, 0);
  DragQueryFile(Msg.Drop, 0, FileName, SizeOf(FileName)-1);

  if(AnsiLowerCase(ExtractFileExt(FileName))='.jpy')then
    loadJPY(FileName);

  DragFinish(Msg.Drop);
end;

procedure TJPYMaker.loadJPY(FileName:string);
var
 openName,dirName,loadFileName:string;
 ini:TMemIniFile;
 sList:TStringList;
 dinf:TDirinf;
 inf:TImageInfo;
 i:Integer;
begin

  openName:=ExtractFileDir(FileName);

  if FileExists(openName+'\summary.wsm')then
  begin
   isSummary:=true;
   scenarioName:=openName;
  end
  else
  begin
   if(selectDirectory('fBNg̑I',baseName+'\Scenario',dirName))then
   begin
    scenarioName:=dirName;
    isSummary:=FileExists(dirName+'\Summary.wsm');
   end
   else
   begin
    scenarioName:=openName;
    isSummary:=false;
   end;
  end;
  middlePath:='';
  openFileName:=FileName;
  pathName:=scenarioName;
  self.openFolder(scenarioName);
  select:=false;
  
  ini:=TMemIniFile.Create(FileName);
  sList:=TStringList.Create();

  try
   ini.ReadSections(sList);
   inf:=director.readInitSection(TCustomIniFile(ini));

   dinf.fileName:=inf.fileName;

   dinf.mode:=inf.dirtype;
   dinf.currentFile:=openName;
   dinf.firstDir:=scenarioName;
   dinf.exeDir:=baseName;
   loadFileName:=TTagText.serachFileName(dinf);

   inc(inf.delCount);
   ViewForm.setInitInf(inf);


   self.ViewForm.lock:=true;

   if(fileExists(loadfileName))then
   begin
    director.loadImage(loadFileName,baseBitmap);
    ViewForm.setInitImage(inf.dirtype,inf.fileName,basebitmap);
   end
   else ViewForm.setInitImage(inf.dirtype,inf.fileName,nil);

   sList.Delete(sList.IndexOf('init'));

   for i:=0 to sList.Count-1 do
   begin
    inf:=director.readSection(TCustomIniFile(ini),sList.Strings[i]);
    dinf.fileName:=inf.fileName;
    dinf.mode:=inf.dirtype;
    dinf.currentFile:=scenarioName;
    dinf.firstDir:=scenarioName;
    dinf.exeDir:=baseName;
    loadFileName:=TTagText.serachFileName(dinf);

    if(fileExists(loadFileName))then
     director.loadImage(loadFileName,baseBitmap)
    else
     baseBitmap.Canvas.FillRect(baseBitmap.Canvas.ClipRect);

    if(inf.posInf.w=-1)then
     inf.posInf.w:=baseBitmap.Width;

    if(inf.posInf.h=-1)then
     inf.posInf.h:=baseBitmap.Height;

    arrangedBitmap.Assign(baseBitmap);
    inc(inf.delCount);
    customizeBitmap(inf,arrangedBitmap);
    inc(inf.delCount);
    ViewForm.setSectionInf(inf,arrangedBitmap);
    inf.FreeEx();
   end;
   self.ViewForm.lock:=false;
   ViewForm.TabControl1Change(self);
   nowFileName:=OpenDialog.FileName;
   self.ViewForm.Show();
  finally
   sList.Free();
   ini.Free();
  end;

end;

end.
