unit ViewForms;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ViewFrame, StdCtrls, Buttons, ComCtrls, initFrames,convImages;

type

  TViewForm = class(TForm)
    ImageFrame1: TImageFrame;
    upBitBtn: TBitBtn;
    downBitBtn: TBitBtn;
    DelBitBtn: TBitBtn;
    PartsListBox: TListBox;
    posPanel: TPanel;
    WidthEdit: TEdit;
    WidthUpDown: TUpDown;
    HeightEdit: TEdit;
    HeightUpDown: TUpDown;
    PosXEdit: TEdit;
    XUpDown: TUpDown;
    PosYEdit: TEdit;
    YUpDown: TUpDown;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    transCheckBox: TCheckBox;
    PaintComboBox: TComboBox;
    backColorLabel: TLabel;
    ColorDialog1: TColorDialog;
    TabControl1: TTabControl;
    partsListPanel: TPanel;
    initFrame1: TinitFrame;
    viewPanel: TPanel;
    backSizePanel: TPanel;
    backWidthEdit: TEdit;
    backHeightEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    backWidthUpDown: TUpDown;
    backHeightUpDown: TUpDown;
    aEdit: TEdit;
    aUpDown: TUpDown;
    seekBitBtn: TBitBtn;
    copyBitBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure DelBitBtnClick(Sender: TObject);
    procedure downBitBtnClick(Sender: TObject);
    procedure upBitBtnClick(Sender: TObject);
    procedure PartsListBoxClick(Sender: TObject);
    procedure PosXEditChange(Sender: TObject);
    procedure backColorLabelClick(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure backWidthEditChange(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure aEditChange(Sender: TObject);
    procedure seekBitBtnClick(Sender: TObject);
    procedure PosXEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure aEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PartsListBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure backWidthEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure copyBitBtnClick(Sender: TObject);
    procedure HeightUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure aUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure backWidthUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    initImageFileName:string;                  
    initDirType:shortInt;
    FNotifySeekEvent:TNotifyArrangeEvent;
    function createParts(inf:TImageInfo;var bitmap:TBitmap):TImageParts;
  public
    { Public 錾 }
  lock:Boolean;
  procedure setInitImage(dirType:shortInt;fileName:string;bitmap:TBitmap);
  function getBackColor():TColor;
  procedure setBackColor(newColor:TColor);
  function getInitInf():TImageInfo;
  procedure setSectionInf(inf:TImageInfo;bitmap:TBitmap);
  procedure reset();
  procedure setPosition();
  procedure drawFrame();
  function getSectionInf(i:Integer):TImageInfo;
  procedure add(inf:TImageInfo;bitmap:TBitmap);
  procedure receiveInf(inf:TImageInfo);
  procedure setInitInf(inf:TImageInfo);
  procedure receiveName(name:string);
  procedure receiveParts(index:Integer;parts:TImageParts);
  procedure setPosInfGUI(inf:TPosInf);
  procedure saveImage(fileName:string;savetype:byte=1);
  property  NotifySeekEvent:TNotifyArrangeEvent
             read FNotifySeekEvent write FNotifySeekEvent;
  property backColor:TColor
   read getBackColor write setBackColor;
  end;

var
  viewForm: TviewForm;

implementation

{$R *.dfm}


(*Xgɐݒp[c*)
procedure TviewForm.add(inf:TImageInfo;bitmap:TBitmap);
var
 i:Integer;
 parts:TImageParts;
begin

 inc(inf.delCount);
 parts:=createParts(inf,bitmap);
 i:=PartsListBox.Items.IndexOf(inf.sectionName);
 bitmap.PixelFormat:=pf32bit;
 bitmap.TransparentColor:=bitmap.Canvas.Pixels[0,0];

 if(i<0)then
 begin
  inc(inf.delCount);
  PartsListBox.Items.AddObject(inf.sectionName,inf);
 end
 else
 begin
  PartsListBox.Items.Objects[i].Free();
  PartsListBox.Items.Objects[i]:=nil;
  inc(inf.delCount);
  PartsListBox.Items.Objects[i]:=inf;
  PartsListBox.Items.Strings[i]:=inf.sectionName;
 end;

  self.lock:=true;
  WidthUpDown.Position:=parts.w;
  HeightUpDown.Position:=parts.h;
  XUpDown.Position:=parts.x;
  YUpDown.Position:=parts.y;
  self.lock:=false;

  inc(inf.delCount);
  ImageFrame1.add(inf.sectionName,parts);

  inf.FreeEx();
end;

function TViewForm.createParts(inf:TImageInfo;var bitmap:TBitmap):TImageParts;
begin
 result:=TImageParts.create();
 result.x:=inf.posInf.x;
 result.y:=inf.posInf.y;
 result.w:=inf.posInf.w;
 result.h:=inf.posInf.h;
 result.alpha:=inf.posInf.alpha;
 result.mode:=inf.posInf.mode;

 if(bitmap<>nil)then
 begin
  result.bitmap.Assign(bitmap);
  result.bitmap.Transparent:=inf.posInf.trans;
  result.bitmap.TransparentColor:=result.bitmap.Canvas.Pixels[0,0];
 end;

 inf.FreeEx();
end;

procedure TViewForm.reset();
begin
 self.lock:=true;
 self.ImageFrame1.reset();
 self.PartsListBox.Clear();
 self.HeightUpDown.Position:=0;
 self.WidthUpDown.Position:=0;
 self.XUpDown.Position:=0;
 self.YUpDown.Position:=0;
 self.transCheckBox.Checked:=false;
 self.PaintComboBox.ItemIndex:=0;
 self.backColorLabel.Color:=clwhite;
 self.backColorLabel.Font.Color:=clblack;
 self.initFrame1.reset();
 self.initImageFileName:='';
 self.initDirType:=-1;
 self.lock:=false;
end;

{ViewFramep[c̈ʒuႤ}
procedure TviewForm.receiveParts(index:Integer;parts:TImageParts);
var
 inf:TPosInf;
begin

 lock:=true;
 try
  if(index>-1)then
  begin
   PartsListBox.Selected[index]:=true;
   inf:=parts.getPosInf();
   setPosInfGUI(inf);
   TImageInfo(PartsListBox.Items.Objects[index]).posInf:=inf;
  end
  else
  begin
   XUpDown.Position:=0;
   YUpDown.Position:=0;
   transCheckBox.Checked:=false;
   PaintComboBox.ItemIndex:=0;
   HeightUpDown.Position:=0;
   WidthUpDown.Position:=0;
   PartsListBox.ItemIndex:=-1;
  end;
 finally
  self.lock:=False;
 end;

end;

procedure TViewForm.FormCreate(Sender: TObject);
begin
 ImageFrame1.NotifyPartsEvent:=self.receiveParts;
 ImageFrame1.NotifyNameEvent:=self.receiveName;
 
 InitFrame1.NotifyArrangeEvent:=self.receiveInf;

end;

{l[󂯎Ė{̂ɒʒm}
procedure TViewForm.receiveName(name:string);
var
 i:Integer;
 inf:TImageInfo;
begin
 i:=PartsListBox.Items.IndexOf(name);
 if(i>-1)then
 begin
  PartsListBox.Selected[i]:=true;
  inf:=TImageInfo(PartsListBox.Items.Objects[i]);
  inc(inf.delCount,1);
  if(assigned(self.FNotifyseekEvent))then
  begin
   inc(inf.delCount);
   NotifySeekEvent(inf);
   inf.FreeEx();
  end;
 inf.FreeEx();
 end;


end;

{p[c̉{}
procedure TViewForm.seekBitBtnClick(Sender: TObject);
var
 i:Integer;
 inf:TImageInfo;
begin
 i:=PartsListBox.ItemIndex;

 if(i>-1)then
 begin
  if(assigned(NotifySeekEvent))then
  begin
   inf:=TImageInfo(PartsListBox.Items.Objects[i]);
   
   if(inf<>nil)then
   begin
    inc(inf.delCount,2);
    NotifySeekEvent(inf);
    inf.FreeEx();
   end
   else
    NotifySeekEvent(inf);
   end;

 end;

end;


{p[c̍폜}
procedure TViewForm.DelBitBtnClick(Sender: TObject);
var
 i:Integer;
begin
 i:=PartsListBox.ItemIndex;

 if(i>-1)then
 begin
   PartsListBox.Items.Objects[i].Free();
   PartsListBox.Items.Delete(i);
   ImageFrame1.delete(i);
   PartsListBoxClick(Sender);
 end;

end;

{p[c̓ւ}
procedure TviewForm.downBitBtnClick(Sender: TObject);
var
 i:Integer;
begin
 i:=PartsListBox.ItemIndex;
 if(i>-1)and(i+1<PartsListBox.Count)then
 begin
  PartsListBox.Items.Exchange(i,i+1);
  ImageFrame1.exchange(i,i+1);
  PartsListBoxClick(Sender);
 end;
end;

{p[c̓ւ}
procedure TviewForm.upBitBtnClick(Sender: TObject);
var
 i:Integer;
begin
 i:=PartsListBox.ItemIndex;
 if(i>0)then
 begin
  PartsListBox.Items.Exchange(i,i-1);
  ImageFrame1.exchange(i,i-1);
  PartsListBoxClick(Sender);
 end;
end;

procedure TviewForm.PartsListBoxClick(Sender: TObject);
var
 inf:TPosInf;
begin
 inf:=ImageFrame1.getLocation(PartsListBox.ItemIndex);
 self.lock:=true;
 WidthUpDown.Position:=inf.w;
 HeightUpDown.Position:=inf.h;
 self.XUpDown.Position:=inf.x;
 self.YUpDown.Position:=inf.y;
 self.aUpDown.Position:=inf.alpha;
 self.PaintComboBox.ItemIndex:=inf.mode;
 self.transCheckBox.Checked:=inf.trans;
 self.lock:=false;
 ImageFrame1.drawSelected();
end;

procedure TViewForm.setPosition();
var
 inf:TPosInf;
begin
 if not (self.lock)then
 begin
  inf.x:=XUpDown.Position;
  inf.y:=YUpDown.Position;
  inf.w:=WidthUpDown.Position;
  inf.h:=HeightUpDown.Position;
  inf.mode:=PaintComboBox.ItemIndex;
  inf.trans:=transCheckBox.Checked;
  inf.alpha:=aUpDown.Position;
  ImageFrame1.setLocation(inf);
 end;
end;

procedure TviewForm.PosXEditChange(Sender: TObject);
begin
 setPosition();
end;

procedure TviewForm.backColorLabelClick(Sender: TObject);
begin
 if(self.ColorDialog1.Execute)then
 begin
  self.setBackColor(ColorDialog1.Color);
  ImageFrame1.repaintParts();
 end;
end;

procedure TviewForm.TabControl1Change(Sender: TObject);
var
 inf:TImageInfo;
begin
 case TabControl1.TabIndex of
  0:
  begin
   ImageFrame1.mode:=ifNormal;
   initFrame1.Visible:=false;
   posPanel.Visible:=true;
   copyBitBtn.Visible:=false;
   partsListPanel.Visible:=true;
   ImageFrame1.repaintParts();
  end;
  1:
  begin
   ImageFrame1.mode:=ifInit;
   partsListPanel.Visible:=false;
   posPanel.Visible:=false;
   initFrame1.Visible:=true;
   copyBitBtn.Visible:=true;
   ImageFrame1.readyInitImage();
   inf:=initFrame1.getImageInfo();
   inc(inf.delCount);
   ImageFrame1.arrangeImage(inf);
   inf.FreeEx();
  end;
 end;  
end;

procedure TviewForm.backWidthEditChange(Sender: TObject);
begin
 ImageFrame1.resizeImage(backWidthUpDown.Position,backHeightUpDown.Position);
end;

procedure TViewForm.BitBtn1Click(Sender: TObject);
begin
 ImageFrame1.arrangeImage(initFrame1.getImageInfo());
end;

(*iniFrameC[W󂯎A摜CĊJ*)
procedure TViewForm.receiveInf(inf:TImageInfo);
begin
 ImageFrame1.arrangeImage(inf);
end;

(*ǂݍ񂾃C[WZbg*)
procedure TViewForm.setInitInf(inf:TImageInfo);
begin
 ImageFrame1.drawlock:=true;
 ImageFrame1.resizeImage(inf.posInf.w,inf.posInf.h);

 inc(inf.delCount);
 initFrame1.setImageInfo(inf);
 ImageFrame1.drawlock:=false;
 self.lock:=true;
 self.backWidthUpDown.Position:=inf.posInf.w;
 self.backHeightUpDown.Position:=inf.posInf.h;
 self.setBackColor(inf.color);
 self.WidthUpDown.Position:=0;
 self.HeightUpDown.Position:=0;
 self.XUpDown.Position:=0;
 self.YUpDown.Position:=0;
 self.transCheckBox.Checked:=false;
 self.lock:=false;
 inf.FreeEx();
end;

(*ǂݍ񂾃p[ct[ɃZbg*)
procedure TViewForm.setSectionInf(inf:TImageInfo;bitmap:TBitmap);
begin
 ImageFrame1.drawlock:=true;
 inc(inf.delCount);
 PartsListBox.Items.AddObject(inf.sectionName,inf);
 self.lock:=true;
 inc(inf.delCount);
 ImageFrame1.add(inf.sectionName,createParts(inf,bitmap));
 self.lock:=false;
 ImageFrame1.drawlock:=false;
 inf.FreeEx();
end;

function TViewForm.getInitInf():TImageInfo;
begin
 result:=self.initFrame1.getImageInfo();
 result.posInf.w:=backWidthUpDown.Position;
 result.posInf.h:=backHeightUpDown.Position;
 result.color:=ImageFrame1.getBackColor;
 result.fileName:=self.initImageFileName;
 result.dirtype:=self.initDirType;
end;

function TViewForm.getSectionInf(i:Integer):TImageInfo;
begin
 if(i<PartsListBox.Items.count)then
 begin
  result:=TImageInfo(PartsListBox.Items.Objects[i]);
  inc(result.delCount);
  result.posInf:=ImageFrame1.getLocation(i);
 end
 else result:=nil;
end;

(*wip̐F*)
function TViewForm.getBackColor():TColor;
begin
 result:=ImageFrame1.getBackColor();
end;

procedure TViewForm.setBackColor(newColor:TColor);
begin
 backColorLabel.Color:=newColor;
 backColorLabel.Font.Color:=newColor xor $ffffff;
 ImageFrame1.setBackColor(newColor);
end;

procedure TViewForm.aEditChange(Sender: TObject);
var
 old:boolean;
begin

  old:=self.lock;

 if(PaintComboBox.ItemIndex<>3)and not(lock)then
  self.lock:=true
 else
  self.lock:=false;

  self.setPosition();

  self.lock:=old;

end;

procedure TViewForm.saveImage(fileName:string;savetype:byte=1);
begin
 ImageFrame1.saveImage(fileName,saveType);
end;

procedure TViewForm.setInitImage(dirType:shortInt;fileName:string;bitmap:TBitmap);
begin
 self.initDirType:=dirtype;
 self.initImageFileName:=fileName;
 self.ImageFrame1.setInitImage(bitmap);
 if not(lock)then self.ImageFrame1.repaintParts();
end;

(*|WV㕔̃o[ɃZbg*)
procedure TViewForm.setPosInfGUI(inf:TPosInf);
begin
 WidthUpDown.Position:=inf.w;
 HeightUpDown.Position:=inf.h;
 XUpDown.Position:=inf.x;
 YUpDown.Position:=inf.y;
 aUpDown.Position:=inf.alpha;
 PaintComboBox.ItemIndex:=inf.mode;
 transCheckBox.Checked:=inf.trans;
end;

procedure TViewForm.PosXEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if(key=VK_RETURN)and not(lock)then
  PosXEditChange(Sender);
end;

procedure TViewForm.aEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

 if(key=VK_RETURN)and not(lock)then
  aEditChange(Sender);
end;

procedure TViewForm.PartsListBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  if not(lock)then
  case key of
   VK_DELETE:DelBitBtnClick(Sender);
   VK_RETURN:seekBitBtnClick(Sender);
  end;

end;

procedure TViewForm.backWidthEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if(key=VK_RETURN)and not(lock)then
  backWidthEditChange(Sender);
end;

procedure TViewForm.drawFrame();
begin

end;

procedure TViewForm.copyBitBtnClick(Sender: TObject);
begin
 saveImage('',2);
end;

procedure TViewForm.HeightUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
 if not(lock)then
  setPosition();
end;

procedure TViewForm.aUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
 if not(lock)then
  aEditChange(Sender);
end;

procedure TViewForm.backWidthUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
  if not(lock)then
  backWidthEditChange(Sender);
end;

procedure TViewForm.FormDestroy(Sender: TObject);
var
 i:Integer;
begin
 for i:=0 to self.PartsListBox.Count -1 do
 begin
  PartsListBox.Items.Objects[i].Free();
 end;
 inherited;
end;

end.
