unit convImages;

interface

uses windows,light,types,classes,graphics,TextImages,iniFiles,jpeg,
SysUtils,ComCtrls,convinf,ClipBrd;

var
 JPYFORMAT:Cardinal;

type
  TBlendImageMode = 0..16;

  TPosInf =record
   x,y,h,w,alpha:Integer;
   mode:ShortInt;
   trans,selected:boolean;
  end;

 TImageInfo=class(TPersistent)
 public
  noisetype,dirtype,Filter,ColorExchange,Mask,ColorMap,cash,turn:Shortint;
  Lights,loadtype:Smallint;
  flip,mirror,mmx,needClip:boolean;
  delCount:Integer;
  color:TColor;
  posInf:TPosInf;
  clip:TRect;
  fileName,sectionName:string;
 // procedure copyWithoutName(inf:TImageInfo);
  procedure Assign(Source: TPersistent);
  procedure FreeEx();
  constructor create();
 end;

 TEDDirector=class(TImageDirector)
 public
  constructor create();
  function loadJpeg(fileName:string;var bitmap:TBitmap):boolean;override;
 // procedure SaveToClipboardFormat(inf:TImageInfo);
  procedure writeSection(var iniFile:TCustomIniFile;inf:TImageInfo);
  procedure writeInitSection(var iniFile:TCustomIniFile;const inf:TImageInfo);
 // function LordFromClipboardFormat():TImageInfo;
  function readInitSection(var iniFile:TCustomIniFile):TImageInfo;
  function readSection(var iniFile:TCustomIniFile;const section:string):TImageInfo;
 end;

{TItemInf=record
 name:string;
end;      }

procedure customizeBitmap(const inf:TImageInfo;var bitmap:TBitmap);

implementation

constructor TImageInfo.create();
begin
 inherited;
 self.delCount:=0;
 self.clip:=Rect(-1,-1,-1,-1);
end;

procedure TImageInfo.FreeEx();
begin
 if(delCount<1)then self.Free()
 else dec(delCount);
end;

procedure TImageInfo.Assign(Source: TPersistent);
begin
 if(Source is TImageInfo)then
 begin
  with Source as TImageInfo do
  begin
   self.noisetype:=noisetype;
   self.Lights:=Lights;
   self.Filter:=Filter;
   self.ColorExchange:=ColorExchange;
   self.Mask:=Mask;
   self.ColorMap:=ColorMap;
   self.turn:=turn;
   self.flip:=flip;
   self.mirror:=mirror;
   self.dirtype:=dirtype;
   self.sectionName:=sectionName;
   self.fileName:=fileName;
   self.needClip:=needClip;
   self.color:=color;
   self.posInf:=posInf;
   self.clip:=clip;
   self.mmx:=mmx;
  end;
 end
 else
  inherited;
end;


(*JPEGt@CǂݍŃrbg}bv`ɂ*)

constructor TEDDirector.create();
begin
 inherited;
 animation:=false;
 searched:=false;
 JPYFORMAT:=RegisterClipboardFormat('JPY_IMAGEINFO');
end;

function TEDDirector.loadJpeg(fileName:string;var bitmap:TBitmap):boolean;
var
 jImage:TJpegImage;
begin

  jImage:=TJpegImage.Create();
  jImage.Performance:=JPEG.jpBestSpeed;
  bitmap:=TBitmap.create();
  try
   JImage.PixelFormat:=jf24Bit;
   JImage.LoadFromFile(fileName);
   bitmap.HandleType:=bmDIB;
   bitmap.PixelFormat:=pf24bit;
   bitmap.Width:=jImage.Width;
   bitmap.Height:=jImage.Height;
   bitmap.Canvas.Draw(0,0,jImage);
   result:=true;
  except
   result:=false;
  end;

  jImage.Free;

end;

function TEDDirector.readInitSection(var iniFile:TCustomIniFile):TImageInfo;
const
 section='init';
var
 vString:string;
 vArray:TIntegerDynArray;
begin
 result:=TImageInfo.Create();
 result.fileName:=iniFile.ReadString(section,'fileName','');
 result.dirtype:=iniFile.ReadInteger(section,'dirtype',-1);
 result.noisetype:=iniFile.ReadInteger(section,'noise',0);
 result.Lights:=iniFile.ReadInteger(section,'noisepoint',0);
 result.posInf.w:=iniFile.ReadInteger(section,'backwidth',632);
 result.posInf.h:=iniFile.ReadInteger(section,'backheight',420);

 result.turn:=iniFile.ReadInteger(section,'turn',0);
 result.ColorExchange:=iniFile.ReadInteger(section,'colorExchange',0);
 result.Filter:=iniFile.ReadInteger(section,'filter',0);
 result.Mask:=iniFile.ReadInteger(section,'mask',0);
 result.ColorMap:=iniFile.ReadInteger(section,'colormap',0);
 result.flip:=iniFile.ReadBool(section,'flip',false);
 result.mirror:=iniFile.ReadBool(section,'mirror',false);
 result.posInf.alpha:=iniFile.ReadInteger(section,'alpha',0);

 vString:=iniFile.ReadString(section,'clip','');
 vArray:=TTagText.getIntArray(vstring,4,-1);
 result.clip:=Bounds(vArray[0],vArray[1],vArray[2],vArray[3]);
 result.needClip:=(vArray[0]>-1)and(vArray[1]>-1)
                   and(vArray[2]>0)and(VArray[3]>0);

 result.color:=
 TTagText.covertColor(iniFile.ReadInteger(section,'backColor',0));

end;

function TEDDirector.readSection(var iniFile:TCustomIniFile;const section:string):TImageInfo;
var
 vString:string;
 vArray:TIntegerDynArray;
begin
 result:=TImageInfo.Create();
 result.sectionName:=section;

 result.fileName:=iniFile.ReadString(section,'fileName','?');
 result.dirtype:=iniFile.ReadInteger(section,'dirtype',4);
 result.posInf.w:=iniFile.ReadInteger(section,'width',-1);
 result.posInf.h:=iniFile.ReadInteger(section,'height',-1);

 vString:=iniFile.ReadString(section,'position','');
 //if(vString<>'')then
// begin
  vArray:=TTagText.getIntArray(vstring,2,0);
  result.posInf.x:=vArray[0];
  result.posInf.y:=vArray[1];
 //end
 //else
// begin
//  result.posInf.x:=iniFile.ReadInteger(section,'position_x',0);
//  result.posInf.y:=iniFile.ReadInteger(section,'position_y',0);
// end;


 result.posInf.mode:=iniFile.ReadInteger(section,'paintmode',0);
 result.posInf.trans:=iniFile.ReadBool(section,'transparent',true);

 result.noisetype:=iniFile.ReadInteger(section,'noise',0);
 result.Lights:=iniFile.ReadInteger(section,'noisepoint',0);
 result.turn:=iniFile.ReadInteger(section,'turn',0);
 result.ColorExchange:=iniFile.ReadInteger(section,'colorExchange',0);
 result.Filter:=iniFile.ReadInteger(section,'filter',0);
 result.Mask:=iniFile.ReadInteger(section,'mask',0);
 result.ColorMap:=iniFile.ReadInteger(section,'colormap',0);
 result.flip:=iniFile.ReadBool(section,'flip',false);
 result.mirror:=iniFile.ReadBool(section,'mirror',false);
 result.posInf.alpha:=iniFile.ReadInteger(section,'alpha',0);

 vString:=iniFile.ReadString(section,'clip','');
 vArray:=TTagText.getIntArray(vstring,4,-1);
 result.clip:=Bounds(vArray[0],vArray[1],vArray[2],vArray[3]);
 
 result.needClip:=(vArray[0]>-1)and(vArray[1]>-1)
                   and(vArray[2]>0)and(VArray[3]>0);


 result.color:=
 TTagText.covertColor(iniFile.ReadInteger(section,'color',0));

end;

procedure TEDDirector.writeInitSection(var iniFile:TCustomIniFile;const inf:TImageInfo);
var
 v:Cardinal;
const
 section='init';
begin

 if(inf.fileName<>'')then
  iniFile.WriteString(section,'fileName',inf.fileName)
 else
  iniFile.DeleteKey(section,'fileName');

 if(inf.dirtype>-1)then
  iniFile.WriteInteger(section,'dirtype',inf.dirtype)
 else
  iniFile.DeleteKey(section,'dirtype');

 if(inf.posInf.w>0)then
  iniFile.WriteInteger(section,'backwidth',inf.posInf.w)
 else
  iniFile.WriteInteger(section,'backwidth',632);

 if(inf.posInf.h>0)then
  iniFile.WriteInteger(section,'backheight',inf.posInf.h)
 else
  iniFile.WriteInteger(section,'backheight',420);

 if(inf.Filter<>0)then
  iniFile.WriteInteger(section,'filter',inf.Filter)
 else
  iniFile.DeleteKey(section,'filter');

 if(inf.ColorExchange<>0)then
  iniFile.WriteInteger(section,'colorExchange',inf.ColorExchange)
 else
  iniFile.DeleteKey(section,'colorExchange');

 if(inf.ColorMap<>0)then
  iniFile.WriteInteger(section,'colorMap',inf.ColorMap)
 else
  iniFile.DeleteKey(section,'colorMap');

 if(inf.Mask<>0)then
  iniFile.WriteInteger(section,'mask',inf.Mask)
 else
  iniFile.DeleteKey(section,'mask');

 v:=TTagText.covertColor(inf.color);
 iniFile.WriteString(section,'backcolor','$'+IntToHex(v,6));

 if(inf.noisetype<>0)or(inf.Lights<>0)then
 begin
  iniFile.WriteInteger(section,'noisepoint',inf.Lights);
  iniFile.WriteInteger(section,'noise',inf.noisetype);
 end
 else
 begin
  iniFile.DeleteKey(section,'noise');
  iniFile.DeleteKey(section,'noisepoint');
 end;

 if(inf.posInf.alpha<>0)then
  iniFile.WriteInteger(section,'alpha',inf.posInf.alpha)
 else
  iniFile.DeleteKey(section,'alpha');

 if(inf.mirror)then
  iniFile.WriteBool(section,'mirror',inf.mirror)
 else
  iniFile.DeleteKey(section,'mirror');

 if(inf.flip)then
  iniFile.WriteBool(section,'flip',inf.flip)
 else
  iniFile.DeleteKey(section,'flip');

 if(inf.turn<>0)then
  iniFile.WriteInteger(section,'turn',inf.turn)
 else
  iniFile.DeleteKey(section,'turn');

 inf.FreeEx();
end;

procedure TEDDirector.writeSection(var iniFile:TCustomIniFile;inf:TImageInfo);
var
 section:string;
begin
 section:=inf.sectionName;

 iniFile.WriteString(section,'fileName',inf.fileName);

 if(inf.posInf.w>0)then
  iniFile.WriteInteger(section,'width',inf.posInf.w)
 else
  iniFile.DeleteKey(section,'width');

 if(inf.posInf.h>0)then
  iniFile.WriteInteger(section,'height',inf.posInf.h)
 else
  iniFile.DeleteKey(section,'height');

 iniFile.WriteString(section,'position',
  IntToStr(inf.posInf.x)+','+IntToStr(inf.posInf.y));

// iniFile.WriteInteger(section,'position_y',inf.posInf.y);
// iniFile.WriteInteger(section,'position_x',inf.posInf.x);
 iniFile.WriteInteger(section,'paintmode',inf.posInf.mode);
 iniFile.WriteBool(section,'transparent',inf.posInf.trans);

 if(inf.Filter<>0)then
  iniFile.WriteInteger(section,'filter',inf.Filter)
 else
  iniFile.DeleteKey(section,'filter');

 if(inf.ColorExchange<>0)then
  iniFile.WriteInteger(section,'colorExchange',inf.ColorExchange)
 else
  iniFile.DeleteKey(section,'colorExchange');

 if(inf.ColorMap<>0)then
  iniFile.WriteInteger(section,'colorMap',inf.ColorMap)
 else
  iniFile.DeleteKey(section,'colorMap');

 if(inf.Mask<>0)then
  iniFile.WriteInteger(section,'mask',inf.Mask)
 else
  iniFile.DeleteKey(section,'mask');

 if(inf.noisetype<>0)or(inf.Lights<>0)then
 begin
  iniFile.WriteInteger(section,'noisepoint',inf.Lights);
  iniFile.WriteInteger(section,'noise',inf.noisetype);
 end
 else
 begin
  iniFile.DeleteKey(section,'noise');
  iniFile.DeleteKey(section,'noisepoint');
 end;

 if(inf.posInf.alpha<>0)then
  iniFile.WriteInteger(section,'alpha',inf.posInf.alpha)
 else
  iniFile.DeleteKey(section,'alpha');

 if(inf.mirror)then
  iniFile.WriteBool(section,'mirror',inf.mirror)
 else
  iniFile.DeleteKey(section,'mirror');

 if(inf.flip)then
  iniFile.WriteBool(section,'flip',inf.flip)
 else
  iniFile.DeleteKey(section,'flip');

 if(inf.turn<>0)then
  iniFile.WriteInteger(section,'turn',inf.turn)
 else
  iniFile.DeleteKey(section,'turn');

 inf.FreeEx(); 
end;

procedure customizeBitmap(const inf:TImageInfo;var bitmap:TBitmap);
var
 v:Integer;
begin

 bitmap.PixelFormat:=pf32bit;

  if(inf.clip.Left>-1)and(inf.clip.Top>-1)
   and(inf.clip.Right>inf.clip.Left)and(inf.clip.Bottom>inf.clip.Top)then
  begin
   light.EffectClip(bitmap,inf.clip);
  end;

 if(inf.ColorExchange>0)then
  light.EffectShiftRGB(bitmap,inf.ColorExchange);

  case inf.Filter of
      8:light.EffectKakusan(bitmap);
     10:light.EffectEnbos(bitmap);
      9:light.EffectNOTMask(bitmap);
      7:bitmap.Mask(bitmap.Canvas.Pixels[0,0]);
   1..6:light.EffectCustom(bitmap,inf.Filter);
  end;

 if(inf.ColorMap>0)then
  light.EffectSepia(bitmap,inf.ColorMap);
                                      
 if(inf.flip)then light.EffectFlip(bitmap);

 if(inf.mirror)then light.EffectMirror(bitmap);

 case inf.noisetype of
  1:light.EffectLightMode(bitmap,inf.Lights);
  2:light.EffectMono(bitmap,inf.Lights);
  3:light.EffectNoize(bitmap,inf.Lights,1);
  4:light.EffectNoize(bitmap,inf.Lights,1);
  5:light.EffectsMosaic(bitmap,inf.Lights);  
 end;

 if(inf.Mask>0)then
  light.EffectThreadLine(bitmap,inf.Mask);

 case inf.turn of
  1:
  begin
   light.EffectsTurn90(bitmap);
   v:=inf.posInf.w;
   inf.posInf.w:=inf.posInf.h;
   inf.posInf.h:=v;
  end;
  2:
  begin
   light.EffectsTurn270(bitmap);
   v:=inf.posInf.w;
   inf.posInf.w:=inf.posInf.h;
   inf.posInf.h:=v;
  end;
 end;



 bitmap.TransparentColor:=bitmap.Canvas.Pixels[0,0];
 inf.FreeEx();
end;



end.
