unit initFrames;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,convImages, ComCtrls;

type

  TNotifyArrangeEvent = procedure(inf:TImageInfo) of object;


  TinitFrame = class(TFrame)
    MaskComboBox: TComboBox;
    RGBComboBox: TComboBox;
    FilterComboBox: TComboBox;
    MirrorCheckBox: TCheckBox;
    FlipCheckBox: TCheckBox;
    ColorMapComboBox: TComboBox;
    Edit1: TEdit;
    noiseUpDown: TUpDown;
    noiseBox: TComboBox;
    turnComboBox: TComboBox;
    BitBtn1: TBitBtn;
    procedure MaskComboBoxChange(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
    FAutoChange:boolean;
    FNotifyArrangeEvent:TNotifyArrangeEvent;
  public
    { Public 錾 }
    lock:boolean;
  published
    bitmap:TBitmap;
    function getImageInfo():TImageInfo;
    procedure setImageInfo(inf:TImageInfo);
    procedure reset();
    constructor create(Owner:TComponent);override;
    property AutoChange:boolean read FAutoChange write FAutoChange;
    property NotifyArrangeEvent:TNotifyArrangeEvent
             read FNotifyArrangeEvent write FNotifyArrangeEvent;
  end;

implementation

{$R *.dfm}

constructor TInitFrame.create(Owner:TComponent);
begin
 inherited;
 lock:=false;
end;

function TinitFrame.getImageInfo():TImageInfo;
begin
 result:=TImageInfo.Create();
 result.Lights:=self.noiseUpDown.Position;
 result.Filter:=self.FilterComboBox.ItemIndex;
 result.Mask:=self.MaskComboBox.ItemIndex;
 result.ColorMap:=self.ColorMapComboBox.ItemIndex;
 result.ColorExchange:=self.RGBComboBox.ItemIndex;
 result.flip:=self.FlipCheckBox.Checked;
 result.mirror:=self.MirrorCheckBox.Checked;
 result.noisetype:=self.noiseBox.ItemIndex;
 result.turn:=self.turnComboBox.ItemIndex;
// inc(result.delCount);
end;

procedure TInitFrame.setImageInfo(inf:TImageInfo);
begin
 self.lock:=true;
 self.noiseUpDown.Position:=inf.Lights;
 self.FilterComboBox.ItemIndex:=inf.Filter;
 self.MaskComboBox.ItemIndex:=inf.Mask;
 self.ColorMapComboBox.ItemIndex:=inf.ColorMap;
 self.RGBComboBox.ItemIndex:=inf.ColorExchange;
 self.FlipCheckBox.Checked:=inf.flip;
 self.MirrorCheckBox.Checked:=inf.mirror;
 self.turnComboBox.ItemIndex:=inf.turn;
 self.lock:=false;
 inf.FreeEx();
end;

procedure TinitFrame.reset();
begin
 self.lock:=true;
 self.noiseUpDown.Position:=0;
 self.FilterComboBox.ItemIndex:=0;
 self.MaskComboBox.ItemIndex:=0;
 self.ColorMapComboBox.ItemIndex:=0;
 self.RGBComboBox.ItemIndex:=0;
 self.FlipCheckBox.Checked:=false;;
 self.MirrorCheckBox.Checked:=false;
 self.turnComboBox.ItemIndex:=0;
 self.lock:=false;
end;

procedure TinitFrame.MaskComboBoxChange(Sender: TObject);
//var
// inf:TImageInfo;
begin
 if not(lock)then
 begin
//  inf:=TImageInfo.Create();
  if(assigned(FNotifyArrangeEvent))then
   NotifyArrangeEvent(getImageInfo());
 end;
end;

procedure TinitFrame.BitBtn1Click(Sender: TObject);
begin
 self.reset();
 MaskComboBoxChange(nil);
end;

end.
