unit textForms;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ActnList, Menus,clipBrd, Buttons, ExtCtrls;

type

  TWrapText = class(TObject)
   headText:string;
   tailText:string;
  end;

  TUndoTextMement = class(TObject)
  public
   deleteLength:Integer;
   InsertText:string;
   startPos:Integer;
   procedure assign(mement:TUndoTextMement);
   procedure copy(mement:TUndoTextMement);
  end;

  TUndoType = (utNone,utKey,utTag,utTest);

  TTextOriginator = class(TObject)
  private
   edit:TCustomEdit;
  public
   undoType:TUndoType;
   function createMement(insString:string):TUndoTextMement;
   function restoreMement(mement:TUndoTextMement):TUndoTextMement;
   procedure setEdit(edit:TCustomEdit);
  { procedure delete();
   procedure cut();
   procedure copy();
   procedure paste();
   procedure sand(text:TWrapText);
   procedure exchange(text:TWrapText);}
  end;

  TMemoForm = class(TForm)
    RichEdit1: TRichEdit;
    PopupMenu1: TPopupMenu;
    Delete1: TMenuItem;
    ActionList1: TActionList;
    deleteAction: TAction;
    undoAction: TAction;
    Undo1: TMenuItem;
    copyAction: TAction;
    Copy1: TMenuItem;
    pasteAction: TAction;
    Paste1: TMenuItem;
    cutAction: TAction;
    Cut1: TMenuItem;
    tagPanel: TPanel;
    decCB: TComboBox;
    insBB: TBitBtn;
    sandBB: TBitBtn;
    insAction: TAction;
    sandAction: TAction;
    N1: TMenuItem;
    N2: TMenuItem;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    procedure deleteActionExecute(Sender: TObject);
    procedure undoActionExecute(Sender: TObject);
    procedure copyActionExecute(Sender: TObject);
    procedure pasteActionExecute(Sender: TObject);
    procedure cutActionExecute(Sender: TObject);
    procedure insBBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sandBBClick(Sender: TObject);
    procedure RichEdit1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    origin:TTextOriginator;
    undoType:TUndoType;
    UndoTextMement:TUndoTextMement;
    procedure makeMement(insString:string);
  public
    { Public 錾 }
   procedure setStrings(items:TStrings);
   function getStrings():TStrings;
  end;


var
  MemoForm: TMemoForm;

implementation

{$R *.dfm}

{TTextOriginator}
procedure TTextOriginator.setEdit(edit:TCustomEdit);
begin
 self.edit:=nil;
 self.edit:=edit;
end;

function TTextOriginator.createMement(insString:string):TUndoTextMement;
begin
 if(edit<>nil)then
 begin
  result:=TUndoTextMement.Create();
  result.startPos:=Edit.SelStart;
  result.InsertText:=Edit.SelText;
  result.deleteLength:=Length(insString);
 end
 else result:=nil;
end;

function TTextOriginator.restoreMement(mement:TUndoTextMement):TUndoTextMement;
var
 s:string;
begin

 result:=TUndoTextMement.Create();
 s:=Edit.Text;

 result.startPos:=mement.startPos;
 result.InsertText:=copy(s,mement.startPos+1,mement.deleteLength);
 result.deleteLength:=Length(mement.InsertText);

 delete(s,mement.startPos+1,mement.deleteLength);
 Insert(mement.InsertText,s,mement.startPos+1);
 Edit.Text:=s;
 Edit.SelStart:=mement.startPos;
 self.undoType:=utTest;

end;

{
procedure TTextOriginator.delete();
begin
  edit.SelText:='';
  undoType:=utTest;
end;

procedure TTextOriginator.cut();
begin
 clipBoard.AsText:=Edit.SelText;
 Edit.SelText:='';
 self.undoType:=utTest;
end;

procedure TTextOriginator.copy();
begin
 clipBoard.AsText:=Edit.SelText;
 self.undoType:=utTest;
end;

procedure TTextOriginator.paste();
begin
 Edit.SelText:=clipboard.AsText;
 self.undoType:=utTest;
end;

procedure TTextOriginator.sand(text:TWrapText);
begin
 Edit.SelText:=text.headText+Edit.SelText+text.tailText;
end;


procedure TTextOriginator.exchange(text:TWrapText);
begin
 Edit.SelText:=text.headText+text.tailText;
end;
}

{TMemoForm}
procedure TMemoForm.setStrings(items:TStrings);
begin
 self.RichEdit1.Clear();
 self.RichEdit1.Lines.AddStrings(items);
end;

function TMemoForm.getStrings():TStrings;
begin
 result:=self.RichEdit1.Lines;
end;

procedure TMemoForm.deleteActionExecute(Sender: TObject);
begin
 makeMement('');
 RichEdit1.SelText:='';
 undoType:=utTest;
end;

procedure TMemoForm.undoActionExecute(Sender: TObject);
var
 //s:string;
 newMement:TUndoTextMement;
begin
 if(self.undoType=utTest)then
 begin
//  newMement:=TUndoTextMement.Create();
  self.RichEdit1.Lines.BeginUpdate;
{  s:=RichEdit1.Text;

  newMement.startPos:=UndoTextMement.startPos;
  newMement.InsertText:=copy(s,UndoTextMement.startPos+1,UndoTextMement.deleteLength);
  newMement.deleteLength:=Length(UndoTextMement.InsertText);

  delete(s,UndoTextMement.startPos+1,UndoTextMement.deleteLength);
  Insert(UndoTextMement.InsertText,s,UndoTextMement.startPos+1);
  RichEdit1.Text:=s;

  UndoTextMement.assign(newMement);
  self.undoType:=utTest;       }
  newMement:=origin.restoreMement(self.UndoTextMement);
  UndoTextMement.assign(newMement);
  self.RichEdit1.Lines.EndUpdate;
  self.undoType:=utTest;

  newMement.Free();
 end
 else if(self.RichEdit1.CanUndo)then
  RichEdit1.Undo;
end;

procedure TMemoForm.copyActionExecute(Sender: TObject);
begin
 clipBoard.AsText:=self.RichEdit1.SelText;
end;

procedure TMemoForm.pasteActionExecute(Sender: TObject);
begin
 self.makeMement(clipboard.AsText);
 self.RichEdit1.SelText:=clipboard.AsText;
 self.undoType:=utTest;
end;

procedure TMemoForm.cutActionExecute(Sender: TObject);
begin
 self.makeMement('');
 clipBoard.AsText:=self.RichEdit1.SelText;
 self.RichEdit1.SelText:='';
 self.undoType:=utTest;
end;

procedure TMemoForm.insBBClick(Sender: TObject);
var
 text:TWrapText;
begin
 if(decCB.ItemIndex>-1)then
 begin
  text:=TWrapText(decCB.Items.Objects [decCB.ItemIndex]);
  self.makeMement('text.headText+text.tailText');
  self.RichEdit1.SelText:=text.headText+text.tailText;
  self.undoType:=utTest;
 end;
end;

procedure TMemoForm.FormCreate(Sender: TObject);
var
 sList,tagList:TStringList;
 i:Integer;
 fileName:string;
 text:TWrapText;

begin
 fileName:=ExtractFileDir(Application.ExeName)+'\jptxTag.ini';
 self.decCB.Clear;
 UndoTextMement:=TUndoTextMement.create();
 origin:=TTextOriginator.Create();
 origin.setEdit(self.RichEdit1);

 if(fileExists(fileName))then
 begin
  sList:=TStringList.Create();
  tagList:=TStringList.Create();
  sList.LoadFromFile(fileName);

  for i:=0 to sList.Count-1 do
  begin
   tagList.CommaText:=sList.Strings[i];
   text:=TWrapText.Create();

   if(tagList.Count>1)then
    text.headText:=tagList.Strings[1];

   if(tagList.Count>2)then
    text.tailText:=tagList.Strings[2];

   decCB.Items.AddObject(tagList.Strings[0],text);
  end;

  sList.Free();
  tagList.Free();

 end;

  if(decCB.Items.Count>0)then
  begin
   decCB.ItemIndex:=0;
  end;

end;

procedure TMemoForm.sandBBClick(Sender: TObject);
var
 text:TWrapText;
 s:string;
begin
 if(decCB.ItemIndex>-1)then
 begin
  text:=TWrapText(decCB.Items.Objects [decCB.ItemIndex]);
  s:=text.headText+RichEdit1.SelText+text.tailText;
  self.makeMement(s);
  RichEdit1.SelText:=s;
  self.undoType:=utTest;  
 end;
end;

procedure TMemoForm.RichEdit1Change(Sender: TObject);
begin
 if(RichEdit1.CanUndo)then
  self.undoType:=utKey
 else
  self.undoType:=utNone;

end;

procedure TMemoForm.BitBtn1Click(Sender: TObject);
var
 s:string;
begin
 self.makeMement('');
 self.RichEdit1.Lines.BeginUpdate;
 s:=RichEdit1.Text;
 Delete(s,RichEdit1.SelStart+1,RichEdit1.SelLength);
 RichEdit1.Text:=s;
 self.RichEdit1.Lines.EndUpdate;
 self.RichEdit1.Modified:=true;
 self.undoType:=utTest;
end;

procedure TMemoForm.FormDestroy(Sender: TObject);
begin
 origin.Free();
 UndoTextMement.Free();
end;

procedure TMemoForm.makeMement(insString:string);
var
 newMement:TUndoTextMement;
begin
// origin.setEdit(self.RichEdit1);
 newMement:=origin.createMement(insString);
 self.UndoTextMement.assign(newMement);
 newMement.Free();
 //self.UndoTextMement.startPos:=self.RichEdit1.SelStart;
 //self.UndoTextMement.InsertText:=self.RichEdit1.SelText;
// self.UndoTextMement.deleteLength:=Length(insString);
end;

procedure TUndoTextMement.copy(mement:TUndoTextMement);
begin
 mement.deleteLength:=self.deleteLength;
 mement.startPos:=self.startPos;
 mement.InsertText:=self.InsertText;
end;

procedure TUndoTextMement.assign(mement:TUndoTextMement);
begin
 self.deleteLength:=mement.deleteLength;
 self.startPos:=mement.startPos;
 self.InsertText:=mement.InsertText;
end;


end.
